/**************************************************************************************************
 * fifo_test_pipe_out.c
 * Test program for the FifoBuffer library, which provides an outbound fifo pipe stream for testing
 * purposes.  Parameter 1 is fifo to connect to. Reads records from pipe and echoes them to stdout
 * until break.
 *-------------------------------------------------------------------------------------------------
 * gcc -g fifo_test_pipe_out.c fifo.c -o fifo_test_pipe_out
 *************************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fifo.h"

int main(int numpars, char * par[])
{  char name[128];
   char buffer[1000], *p, ans[15];
   FIFO * fifo;
   FILE * fp;
   int rc;
   
   if (numpars < 1) { printf("par 1=fifo name"); exit(1); }
   strcpy(name,par[1]);
   
   fifo = fifoOpen(name, FIFO_INPUT, FIFO_BLOCK | FIFO_IOLBF);
   if (!fifo) { PrtFifoErrorString(stdout, "fifoOpen"); exit(1); }
   
   while (1)
   {  rc = fifoGet(fifo, buffer, sizeof(buffer));
      if (rc == FIFO_R_FAIL) PrtFifoErrorString(stdout, "fifoPut");
      printf("%s\n", buffer);
   }
}
      
