// %W% %U% %G%
//
//    MBroadcastAccountant
//
//
//
//    Steve Moore, 4-Jan-1999

#ifndef MBroadcastAccountant_IS_IN
#define MBroadcastAccountant_IS_IN

#include <vector>
#include <map>
#include <string>

#include "MStorageKey.hpp"
#include "MStorageResult.hpp"

#include "dcm_api.h"


class MBroadcastAccountant {
public:
  typedef map<MStorageKey, MStorageResult, less<MStorageKey> > mba_map;

  // Constructors
  MBroadcastAccountant();

  virtual ~MBroadcastAccountant();

  virtual void print( ostream& s) const;

  void broadcastMap(const char* directory, const char* AETitle);
  vector<char*> destinationVector(const char* directory, const char* AETitle);
  int storageResult(const char* directory, const char* AETitle, const char* image, const char* destination, int result);
  int storageResult(const char* directory, const char* AETitle, const char* image, const char* destination);
  int recordStatus(const char* directory, const char* AETitle);
  int readStatus(const char* directory, const char* AETitle);

  void cleanup(const char* directory, const char* AETitle);

  void beginExport(const char* reportMgr,
	int count, const char* dir, const char* path,
	const char* host, const char* queueName,
	const char* exportSequence,
	long queueNumber, long jobSequence);

  void endExport(const char* reportMgr,
	int count, const char* dir, const char* path,
	const char* host, const char* queueName,
	const char* exportSequence,
	long queueNumber, long jobSequence,
	unsigned long bytesExported,
	const char* statusText);

  void beginImage(const char* reportMgr, const char * host, const char* queueName, int index, int totalCount);

  int nextSequenceNumbers(const char* queue, long& queueNumber, long& jobSequence);

private:
  string mCurrentDirectory;
  string mCurrentAETitle;
  mba_map mResultMap; 
  char mStartDate[64];
  char mStartTime[64];
  char mEndDate[64];
  char mEndTime[64];

  DCM_OBJECT* openFile(const char* dir, const char* path);
  void getString(DCM_OBJECT* obj, DCM_TAG tag, char* buf);
};

inline ostream& operator <<(ostream& s, const MBroadcastAccountant& c) {
  c.print( s );
  return s;
}
#endif
