static char sccs_id[] = "// %W% %U% %G%";

//  MBroadcastManager
//
//  Steve Moore, 17-Sep-96

#include <iostream>
using namespace std;
#include "ctn_os.h"
#include "MBroadcastManager.hpp"
#include "MBroadcastAccountant.hpp"
#include "MStorageClient.hpp"


MBroadcastManager::MBroadcastManager( ) { }

/*virtual*/
MBroadcastManager::~MBroadcastManager() { }

void MBroadcastManager::print (ostream& s) const { s << "MBroadcastManager"; }

int
MBroadcastManager::broadcast(const char* reportMgr,
			     const char* AETitle, 
              const char* AEOveride,
              const char* directory,
			     vector<char*> images,
			     const char* host,
			     const char* queueName)
{

  MBroadcastAccountant accountant;

  accountant.broadcastMap(directory, AETitle);
  accountant.readStatus(directory, AETitle);
  vector<char*> destinations = accountant.destinationVector(directory, AETitle);

  MStorageClient storageClient;
  int status;
  char* statusText = "SUCCESS";

  int returnResult = 0;

  long queueNumber = 0;
  long jobSequence = 0;

  unsigned long bytesExported = 0;

  int totalBroadcastCount = images.size() * destinations.size();
  int broadcastIndex = 0;

   for (int i = 0; i < destinations.size(); i++) 
   {  for (int j = 0; j < images.size(); j++, broadcastIndex++) 
      {  if ((broadcastIndex % 5) == 0) 
         {  accountant.beginImage(reportMgr, host, queueName, broadcastIndex, totalBroadcastCount);
         }
         if (accountant.storageResult(directory, AETitle, images[j], destinations[i]) != DCM_STATUS_SUCCESS) 
         {  status = storageClient.storeImage(directory, AEOveride, images[j], destinations[i], bytesExported);
	         if (status != DCM_STATUS_SUCCESS) returnResult = 1;
	         accountant.storageResult(directory, AETitle, images[j], destinations[i], status);
         }
      }
   }
   accountant.recordStatus(directory, AETitle);

   if (images.size() > 0) {if(returnResult != 0) statusText="FAILURE"; }
  return returnResult;
}

