//  MReportManager
//
//  Steve Moore, 2001.10.23

#include <ostream>
using namespace std;
#include "ctn_os.h"

#include "MReportManager.hpp"
#include "MStatusMessage.hpp"

//#include <stdio.h>
//#include <unistd.h>
//#include <sys/types.h>
//#include <sys/socket.h>
//#include <netinet/in.h>
//#include <netdb.h>

MReportManager::MReportManager( )
{
}

/*virtual*/
MReportManager::~MReportManager()
{
}

void
MReportManager::print (ostream& s) const
{
  s << "MReportManager: "
    << endl;
}

void
MReportManager::sendMessage(const char* destination,
	MStatusMessage& msg)
{
  char buf[10240];
  int len = 0;
  int status = msg.serialize(buf+6, sizeof(buf)-6, len);
  if (status != 0) {
    return;
  }
  char txt[20];
  ::sprintf(txt, "%06d", len);
  ::memcpy(buf, txt, 6);

  int s = this->connect(destination);

  if (s <= 0) {
    return;
  }

  //cout << buf << endl;
  if (::write(s, buf, len+6) != len+6) {
    this->close(s);
    return;
  }
  char ackMsg[8192];
  this->receiveAck(s, ackMsg);
  //cout << ackMsg << endl;

  this->close(s);
}


// Private methods below here


int
MReportManager::connect(const char* destination)
{
  char buf[128] = "";
  char host[128] = "";
  int port;

  ::strcpy(buf, destination);
  char *c = ::strtok(buf, ":");
  strcpy (host, c);

  c = ::strtok(0, ":");
  port = atoi(c);

  struct sockaddr_in server;
  struct hostent *hp;
  int s;

  s = ::socket(AF_INET, SOCK_STREAM, 0);
  if (s < 0)
    return 0;

  server.sin_family = AF_INET;
  hp = gethostbyname(host);
  if (hp == 0)
    return 0;

  (void) ::memcpy(&server.sin_addr, hp->h_addr, (unsigned long) hp->h_length);
  server.sin_port = (u_short) htons(port);

  if (::connect(s, (struct sockaddr*) &server, sizeof(server)) < 0) {
    ::close(s);
    return 0;
  }
  return s;
}

void
MReportManager::close(int fd)
{
  ::close(fd);
}

void
MReportManager::receiveAck(int s, char* ackMsg)
{
  int x = ::read(s, ackMsg, 2);

  if (x != 2)
    return;

  ackMsg[2] = '\0';
}

#if 0
// Version with message length and ACK string
void
MReportManager::receiveAck(int s, char* ackMsg)
{
  int x = ::read(s, ackMsg, 6);

  if (x != 6)
    return;

  ackMsg[6] = '\0';

  int len = atoi(ackMsg);

  ackMsg += 6;
  while (len > 0) {
    x = ::read(s, ackMsg, len);
    if (x <= 0)
      return;
    ackMsg += x;
    ackMsg[0] = '\0';
    len -= x;
  }
}
#endif
