//  MStatusMessage
//
//  Steve Moore, 2001.10.22

#if 0
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#endif

#include <iostream>
using namespace std;
#include "ctn_os.h"

#include "MStatusMessage.hpp"


MStatusMessage::MStatusMessage( ) :
  mType("")
{
}

/*virtual*/
MStatusMessage::~MStatusMessage()
{
}

void
MStatusMessage::print (ostream& s) const
{
  s << "MStatusMessage: "
    << mType << endl;
}

void
MStatusMessage::messageType(const char* type)
{
  mType = type;
}

void
MStatusMessage::addAttribute(const char* name, const char* value)
{
  mAttributeMap[name] = value;
}

int
MStatusMessage::serialize(char* buf, size_t len, int& rtnLength)
{
  int l = this->computeMessageLength();
  if (l + 1 > len)
    return -1;

  rtnLength = 0;

  const char *c = 0;
  int l1;

  char* p = buf;
  strcpy(p, "msg=");
  rtnLength += ::strlen(p);
  p += ::strlen(p);

  c = mType.data();
  l1 = mType.length();
  ::strncpy(p, c, l1);
  p += l1;
  rtnLength += l1;

  string_map::iterator ix = mAttributeMap.begin();

  string n;
  string v;
  for (; ix != mAttributeMap.end(); ix++) {
    n = (*ix).first;
    v = (*ix).second;
    *p++ = '&';
    rtnLength++;

    c = n.data();
    l1 = n.length();
    ::strncpy(p, c, l1);
    p += l1;
    rtnLength += l1;

    *p++ = '=';
    rtnLength++;

    c = v.data();
    l1 = v.length();
    ::strncpy(p, c, l1);
    p += l1;
    rtnLength += l1;
  }
  *p = '\0';

  if (rtnLength != l) {
    cout << "Estimated message Length is: " << l
	<< " and actual length is: " << rtnLength << endl;
    return -2;
  }

  return 0;
}

// Private methods follow below

int
MStatusMessage::computeMessageLength()
{
  int len = 0;

  string s("msg=");
  len += s.length();
  len += mType.length();

  string_map::iterator ix = mAttributeMap.begin();

  string n;
  string v;
  for (; ix != mAttributeMap.end(); ix++) {
    n = (*ix).first;
    v = (*ix).second;
    len += 1			// "&"
	+ n.length()
	+ 1			// "="
	+ v.length();
  }

  return len;
}
