// %W% %U% %G%
//
//    MStatusMessage
//
//
//
//    Steve Moore, 2001.10.22

#ifndef MStatusMessage_IS_IN
#define MStatusMessage_IS_IN

#include <vector>
#include <map>
#include <string>

class MStatusMessage {
public:
  typedef map<string, string, less<string> > string_map;

  // Constructors
  MStatusMessage();

  virtual ~MStatusMessage();

  virtual void print( ostream& s) const;

  void messageType(const char* type);

  void addAttribute(const char* name, const char* value);

  int serialize(char* buf, size_t len, int& rtnLength);

private:
  string mType;
  string_map mAttributeMap;

  int computeMessageLength();

};

inline ostream& operator <<(ostream& s, const MStatusMessage& c) {
  c.print( s );
  return s;
}
#endif
