// %W% %U% %G%
//
//    MStorageClient
//
//
//
//    Steve Moore, 4-Jan-1999

#ifndef MStorageClient_IS_IN
#define MStorageClient_IS_IN

#include "dcm_api.h"

#include <string>

class MStorageClient {
public:

  // Constructors
  MStorageClient();

  virtual ~MStorageClient();

  virtual void print( ostream& s) const;

  int storeImage(const char* directory, const char* AETitle,
		 const char* fileName, const char* destination,
		 unsigned long& bytesExported);

private:
  DUL_NETWORKKEY* _networkKey;
  DUL_ASSOCIATIONKEY* _associationKey;
  DUL_ASSOCIATESERVICEPARAMETERS _parameters;
  string _currentServer;
  string _currentAETitle;
  string _currentSOPClass;
  unsigned long mBytesTransmitted;


  int openFile(const char* directory, const char* fileName,
	       DCM_OBJECT** obj);
  int closeFile(DCM_OBJECT** obj);
  int connectToServer(const char* AETitle, const char* destination,
		      DCM_OBJECT** obj);
  int storeImage(DCM_OBJECT** obj);
  int disconnect();
};

inline ostream& operator <<(ostream& s, const MStorageClient& c) {
  c.print( s );
  return s;
}
#endif
