// %W% %U% %G%
//
//    MStorageKey
//
//
//
//    Steve Moore, 5-Jan-1999

#ifndef MStorageKey_IS_IN
#define MStorageKey_IS_IN

#include <string>

class MStorageKey {
public:

  // Constructors
  MStorageKey(const char* fileName, const char* destination);
  MStorageKey(const string& fileName, const string& destination);

  MStorageKey(const MStorageKey& rhs);
  const MStorageKey& operator=( const MStorageKey& rhs );

  virtual ~MStorageKey();

  bool operator==(const MStorageKey& other) const;
  bool operator!=(const MStorageKey& other) const;
  bool operator < (const MStorageKey& other) const;

  virtual void print( ostream& s) const;

  string fileName() const { return _fileName; };
  string destination() const { return _destination; };

private:
  string _fileName;
  string _destination;

};

inline ostream& operator <<(ostream& s, const MStorageKey& c) {
  c.print( s );
  return s;
}
#endif
