// %W% %U% %G%
//
//    MStorageResult
//
//
//
//    Steve Moore, 5-Jan-1999

#ifndef MStorageResult_IS_IN
#define MStorageResult_IS_IN

#include <string>

class MStorageResult {
public:

  // Constructors
  MStorageResult(const char* fileName, const char* destination,
		 int count, int result);
  MStorageResult(const string& fileName, const string& destination,
		 int count, int result);

  MStorageResult(const MStorageResult& rhs);
  const MStorageResult& operator=( const MStorageResult& rhs );

  virtual ~MStorageResult();

  bool operator==(const MStorageResult& other) const;
  bool operator!=(const MStorageResult& other) const;
  bool operator < (const MStorageResult& other) const;

  virtual void print( ostream& s) const;

  string fileName() const { return _fileName; };
  string destination() const { return _destination; };
  int count() const { return _count; };
  int result() const { return _result; };

  void count(int count) { _count = count; };
  void result(int result) { _result = result; };

private:
  string _fileName;
  string _destination;
  int _count;
  int _result;

 
};

inline ostream& operator <<(ostream& s, const MStorageResult& c) {
  c.print( s );
  return s;
}
#endif
