#ifndef _MIRCS_SIMPLE_STORAGE_H_
#define _MIRCS_SIMPLE_STORAGE_H_
/******************************************************************************
 * mircs_simple_storage.h                                             R Moulton
 * Header file for MIR Computer section modifications to simple_storage.
 *****************************************************************************/

/*------------------------ Function prototypes ------------------------------*/

void MIRCS_Setup(char * prog, char * imgs);
void MIRCS_ObjectReceived(const char * fileName, DCM_OBJECT * obj, 
      char * newDirectory, size_t sizeof_newDirectory,
      char * newName, size_t sizeof_newName);
void MIRCS_EndConnection(void);
void MIRCS_Reset(void);

/*-----------------------------------------------------------------------------
 * simple_storage has a listen process, and forks a new process to handle each
 * study received.  To debug this child process using gdb, we have to attach it
 * after the fork.  This parameter indicates how many seconds to wait after the
 * fork to allow the gdb attach, and is controlled by the "DebugPause" entry in
 * the MAIN section of the MIRCS .ini file. Zero is the default, used in 
 * production environments.
 *---------------------------------------------------------------------------*/
extern int MIRCS_dbg_pause;

#endif
