#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# ifndef YYLMAX 
# define YYLMAX BUFSIZ
# endif 
#ifndef __cplusplus
# define output(c) (void)putc(c,yyout)
#else
# define lex_output(c) (void)putc(c,yyout)
#endif

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
	int yyback(int *, int);
	int yyinput(void);
	int yylook(void);
	void yyoutput(int);
	int yyracc(int);
	int yyreject(void);
	void yyunput(int);
	int yylex(void);
#ifdef YYLEX_E
	void yywoutput(wchar_t);
	wchar_t yywinput(void);
#endif
#ifndef yyless
	int yyless(int);
#endif
#ifndef yywrap
	int yywrap(void);
#endif
#ifdef LEXDEBUG
	void allprint(char);
	void sprint(char *);
#endif
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#ifdef __cplusplus
extern "C" {
#endif
	void exit(int);
#ifdef __cplusplus
}
#endif

#endif
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
#ifndef __cplusplus
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#else
# define lex_input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#endif
#define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng;
#define YYISARRAY
char yytext[YYLMAX];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;

# line 3 "lex.l"
/*
+-+-+-+-+-+-+-+-+-
*/

# line 6 "lex.l"
/*
**		     Electronic Radiology Laboratory
**		   Mallinckrodt Institute of Radiology
**		Washington University School of Medicine
**
** Module Name(s):
** Author, Date:	Aniruddha Gokhale, 24-May-1995
** Intent:		This file defines lexical rules that define valid tokens
**			of a DICOM object
** Last Update:		$Author: asg $, $Date: 1995/07/07 16:41:06 $
** Source File:		$RCSfile: lex.l,v $
** Revision:		$Revision: 1.6 $
** Status:		$State: Exp $
*/

static char rcsid[] = "$Revision: 1.6 $ $RCSfile: lex.l,v $";
#include <stdio.h>
#include "modify.h"
#include "gram.h"

static int count = 0;
static unsigned short IsMultVal = 0;
static unsigned short IsTag = 0;
#define RET(a)		if (verbose) ECHO; return (a);

# line 32 "lex.l"
/* define an additional state */
# define STATE_VALUE 2
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
#ifdef __cplusplus
/* to avoid CC and lint complaining yyfussy not being used ...*/
static int __lex_hack = 0;
if (__lex_hack) goto yyfussy;
#endif
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:

# line 35 "lex.l"
{  /* ignore comments */ }
break;
case 2:

# line 36 "lex.l"
{
    		BEGIN 0;
    		RET( *yytext);
	}
break;
case 3:

# line 40 "lex.l"
{
		IsMultVal = 1;
		RET( *yytext); /* start of a multiply-valued string */
	}
break;
case 4:

# line 44 "lex.l"
{
		IsMultVal = 0;
		BEGIN 0;	/* end of value. */
		RET( *yytext); /* start of a multiply-valued string */
	}
break;
case 5:

# line 49 "lex.l"
{
		IsTag = 1;
		RET( *yytext);
	}
break;
case 6:

# line 53 "lex.l"
{
		IsTag = 0;
		RET( *yytext);
	}
break;
case 7:

# line 57 "lex.l"
{
		  RET( *yytext);
	}
break;
case 8:

# line 60 "lex.l"
{
    		strcpy(yylval.str, &yytext[1]);
		yylval.str[yyleng-2] = 0;
    		if (!IsMultVal)
			BEGIN 0;
    		RET( VALUE);
	}
break;
case 9:

# line 67 "lex.l"
{
    		strcpy(yylval.str, yytext);
    		if (!IsMultVal && !IsTag)
			BEGIN 0;
    		RET( VALUE);
	}
break;
case 10:

# line 73 "lex.l"
	{
    		sscanf(yytext, "%x", &yylval.num);
    		count = (count + 1) % 2;
    		if (!count)
			BEGIN STATE_VALUE;
    		/* next state is STATE_VALUE */
    		RET( NUMBER);
	}
break;
case 11:

# line 81 "lex.l"
case 12:

# line 82 "lex.l"
	{ RET( *yytext); }
break;
case 13:

# line 83 "lex.l"
{ if (verbose) ECHO; /* nothing */ }
break;
case 14:

# line 84 "lex.l"
 	{ printf("Unknown character: %c\n", *yytext); }
break;
case -1:
break;
default:
(void)fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
int yyvstop[] = {
0,

13,
0, 

13,
0, 

13,
0, 

13,
0, 

14,
0, 

13,
14,
0, 

13,
0, 

11,
14,
0, 

12,
14,
0, 

14,
0, 

10,
14,
0, 

9,
14,
0, 

9,
14,
0, 

2,
11,
14,
0, 

7,
14,
0, 

9,
14,
0, 

9,
10,
14,
0, 

5,
14,
0, 

6,
14,
0, 

3,
14,
0, 

4,
14,
0, 

1,
0, 

10,
0, 

9,
0, 

9,
0, 

8,
9,
0, 

1,
9,
0, 

9,
10,
0, 

8,
0, 
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,5,	0,0,	
0,0,	0,0,	0,0,	26,26,	
0,0,	0,0,	1,6,	1,7,	
0,0,	3,12,	6,7,	6,7,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	28,28,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	28,0,	
4,12,	0,0,	0,0,	1,5,	
0,0,	6,7,	0,0,	0,0,	
26,30,	1,8,	1,9,	0,0,	
0,0,	1,5,	3,13,	0,0,	
1,10,	1,11,	2,5,	10,22,	
3,14,	2,10,	26,26,	28,28,	
3,15,	0,0,	0,0,	3,16,	
3,17,	1,5,	0,0,	1,5,	
0,0,	4,13,	2,5,	0,0,	
2,5,	28,28,	0,0,	4,14,	
3,18,	0,0,	3,19,	4,15,	
0,0,	0,0,	4,16,	4,17,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4,18,	
0,0,	4,19,	11,23,	11,23,	
11,23,	11,23,	11,23,	11,23,	
11,23,	11,23,	11,23,	11,23,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	11,23,	
11,23,	11,23,	11,23,	11,23,	
11,23,	0,0,	0,0,	12,24,	
0,0,	0,0,	0,0,	0,0,	
1,5,	0,0,	1,5,	12,0,	
12,0,	2,5,	13,25,	2,5,	
0,0,	0,0,	0,0,	3,20,	
0,0,	3,21,	13,26,	13,26,	
0,0,	16,0,	16,0,	11,23,	
11,23,	11,23,	11,23,	11,23,	
11,23,	0,0,	12,0,	0,0,	
12,24,	0,0,	4,20,	0,0,	
4,21,	0,0,	12,0,	12,0,	
0,0,	0,0,	12,0,	13,27,	
16,0,	0,0,	12,24,	17,0,	
17,0,	13,26,	13,26,	0,0,	
16,0,	16,0,	22,22,	0,0,	
16,0,	13,25,	12,0,	16,28,	
12,0,	0,0,	22,22,	22,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	17,0,	0,0,	
16,0,	0,0,	16,0,	0,0,	
24,0,	24,0,	17,0,	17,0,	
0,0,	0,0,	17,0,	27,0,	
27,0,	0,0,	17,29,	22,22,	
0,0,	0,0,	0,0,	0,0,	
0,0,	22,22,	22,22,	0,0,	
0,0,	0,0,	17,0,	24,0,	
17,0,	22,22,	0,0,	0,0,	
0,0,	0,0,	27,0,	24,0,	
24,0,	29,0,	29,0,	24,0,	
0,0,	0,0,	27,0,	27,0,	
0,0,	0,0,	27,0,	0,0,	
0,0,	12,0,	0,0,	12,0,	
0,0,	0,0,	0,0,	24,0,	
0,0,	24,0,	0,0,	0,0,	
29,0,	0,0,	27,0,	16,0,	
27,0,	16,0,	0,0,	0,0,	
29,0,	29,0,	0,0,	0,0,	
29,0,	0,0,	0,0,	0,0,	
29,29,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
29,0,	17,0,	29,0,	17,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	24,0,	0,0,	
24,0,	0,0,	0,0,	0,0,	
0,0,	27,0,	0,0,	27,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	29,0,	
0,0,	29,0,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		yyvstop+1,
yycrank+-6,	yysvec+1,	yyvstop+3,
yycrank+-12,	yysvec+1,	yyvstop+5,
yycrank+-31,	yysvec+1,	yyvstop+7,
yycrank+0,	0,		yyvstop+9,
yycrank+5,	0,		yyvstop+11,
yycrank+0,	yysvec+6,	yyvstop+14,
yycrank+0,	0,		yyvstop+16,
yycrank+0,	0,		yyvstop+19,
yycrank+4,	0,		yyvstop+22,
yycrank+46,	0,		yyvstop+24,
yycrank+-118,	0,		yyvstop+27,
yycrank+-129,	0,		yyvstop+30,
yycrank+0,	0,		yyvstop+33,
yycrank+0,	0,		yyvstop+37,
yycrank+-132,	yysvec+12,	yyvstop+40,
yycrank+-158,	yysvec+12,	yyvstop+43,
yycrank+0,	0,		yyvstop+47,
yycrank+0,	0,		yyvstop+50,
yycrank+0,	0,		yyvstop+53,
yycrank+0,	0,		yyvstop+56,
yycrank+-173,	0,		yyvstop+59,
yycrank+0,	yysvec+11,	yyvstop+61,
yycrank+-187,	yysvec+12,	yyvstop+63,
yycrank+0,	yysvec+13,	yyvstop+65,
yycrank+-6,	yysvec+13,	0,	
yycrank+-194,	yysvec+12,	yyvstop+67,
yycrank+-21,	yysvec+22,	yyvstop+70,
yycrank+-220,	yysvec+12,	yyvstop+73,
yycrank+0,	0,		yyvstop+76,
0,	0,	0};
struct yywork *yytop = yycrank+345;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
  0,   1,   1,   1,   1,   1,   1,   1, 
  1,   9,  10,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  9,   1,  34,   1,   1,   1,   1,   1, 
 40,  41,   1,   1,  41,   1,   1,   1, 
 48,  48,  48,  48,  48,  48,  48,  48, 
 48,  48,   1,   1,  41,   1,  41,   1, 
  1,  48,  48,  48,  48,  48,  48,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,  48,  48,  48,  48,  48,  48,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,  41,   1,  41,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*	Copyright (c) 1989 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#pragma ident	"@(#)ncform	6.12	97/12/08 SMI"

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
#if defined(__cplusplus) || defined(__STDC__)
int yylook(void)
#else
yylook()
#endif
{
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
#ifndef __cplusplus
			*yylastch++ = yych = input();
#else
			*yylastch++ = yych = lex_input();
#endif
#ifdef YYISARRAY
			if(yylastch > &yytext[YYLMAX]) {
				fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
				exit(1);
			}
#else
			if (yylastch >= &yytext[ yytextsz ]) {
				int	x = yylastch - yytext;

				yytextsz += YYTEXTSZINC;
				if (yytext == yy_tbuf) {
				    yytext = (char *) malloc(yytextsz);
				    memcpy(yytext, yy_tbuf, sizeof (yy_tbuf));
				}
				else
				    yytext = (char *) realloc(yytext, yytextsz);
				if (!yytext) {
				    fprintf(yyout,
					"Cannot realloc yytext\n");
				    exit(1);
				}
				yylastch = yytext + x;
			}
#endif
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (uintptr_t)yyt > (uintptr_t)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((uintptr_t)yyt < (uintptr_t)yycrank) {	/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
#ifndef __cplusplus
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
#else
		yyprevious = yytext[0] = lex_input();
		if (yyprevious>0)
			lex_output(yyprevious);
#endif
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
#if defined(__cplusplus) || defined(__STDC__)
int yyback(int *p, int m)
#else
yyback(p, m)
	int *p;
#endif
{
	if (p==0) return(0);
	while (*p) {
		if (*p++ == m)
			return(1);
	}
	return(0);
}
	/* the following are only used in the lex library */
#if defined(__cplusplus) || defined(__STDC__)
int yyinput(void)
#else
yyinput()
#endif
{
#ifndef __cplusplus
	return(input());
#else
	return(lex_input());
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyoutput(int c)
#else
yyoutput(c)
  int c; 
#endif
{
#ifndef __cplusplus
	output(c);
#else
	lex_output(c);
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyunput(int c)
#else
yyunput(c)
   int c; 
#endif
{
	unput(c);
	}
