#ifndef _SQL_H_
#define _SQL_H_
/**************************************************************************************************
 * sql.h                                                                                  R Moulton
 * Header file for mysql database routines
 *-------------------------------------------------------------------------------------------------
 * 13-3 R Moulton Initial write
 *************************************************************************************************/
#include <mysql.h>

struct _result_field_ {
   char * name;            /* column name */
   char * table;
   char * db; 
   char row;               /* row # in result set, or -1 if not present */
};
/*-------------------------------------------------------------------------------------------------
 * Error numbers below 1000 are assigned by sql.c.  1### numbers are mysql client errors 
 * (see errmsg.h), and 2### numbers are server errors (see mysqld_error.h).
 *-----------------------------------------------------------------------------------------------*/
unsigned int sql_errno;

#define SQL_OK            0
#define SQL_NODBNAME      1
#define SQL_NOUSER        2
#define SQL_NOINIPFN      3
#define SQL_INI           4
#define SQL_INITFAIL      5
#define SQL_ININOF        6
#define SQL_SECNOF        7
#define SQL_NOFIELDS      8
#define SQL_NOCONN        9
#define SQL_NOQUERY      10
#define SQL_NORESULTS    11
#define SQL_NOCOLS       12
#define SQL_MALLOC       13

/*------------------------------------------------------------------------------- Flag constants */
#define SQLF_NO_FLAGS      0x0000
#define SQLF_LOW_PRIORITY  0x0001
#define SQLF_DELAYED       0x0002
#define SQLF_IGNORE        0x0004

int sqlInitialize(char * pfn);
MYSQL * sqlOpen(char * db, char * user);
int sqlClose(MYSQL * conn);
void * sqlSelect(MYSQL * conn, char * sql_query, struct _result_field_ * fields, int * rows, void * old);
char * GetSqlErrorString(MYSQL * conn);
void PrtSqlErrorString(MYSQL * conn, FILE * file, char * prefix);

#endif
