#ifndef _DBG_H_
#define _DBG_H_

/**************************************************************************************************
 * dbg.h                                                                                  R Moulton
 * Header file for utility routines used for debugging prints
 *-------------------------------------------------------------------------------------------------
 * 11-3 R Moulton Initial write
 *************************************************************************************************/

static char em[256];

FILE * debug_on(char *pfn);  /* Turns on debug, messages on file pfn (can be stdout, stderr) */
void debug_off(void);      /* Turns debug off; This is default */
void dbg(char * msg);      /* Prints simple debug message */
void dbg_exit(char * msg, int status);      /* dbg, then exit with status */
void dbge(char * prefix);  /* Prints debug on errno, like perror */
void dbge_exit(char * prefix, int status);  /* dbge, then exit with status */
FILE * debug_is_on(void);     /* Returns debug FILE * if debug is on, NULL if debug is off */
void debug_sleep(int mins);    /* Sleeps if debug on (used to attach to child with debugger) */

#endif

