#!/bin/csh

#***********************************************************************
# BCheck.csh                                                   R Moulton
#
# Checks status of production dicom broadcast queues, using broadcast
# logs.  Command format:
#
# Bcheck.csh lines
#-----------------------------------------------------------------------
# 5-8-2 R Moulton - Modified to eliminate servername parameter
# 6-3-3 R Moulton - Modified to eliminate dir params and add message
#***********************************************************************
set S = $SNAME   
set LINES = 4 
if ($1 != "") set LINES = $1
echo ============================================================
echo "Distributor status for $S `date`"
if (-e $BIN/Bcheck.message) then
	echo ============================================================
	cat $BIN/Bcheck.message
endif
echo ============================================================
echo "------------- scripts locked & stopped --------------------"
cd $TMP
ls *lock* *stop* 
if (-e $LOG/Router.log) then
   echo
   echo ----------------------- Router -----------------------------
   tail -$LINES $LOG/Router.log
endif
if (-e $LOG/HRouter.log) then
   echo
   echo ---------------- High Priority Router ----------------------
   tail -$LINES $LOG/HRouter.log
endif
if (-e $LOG/PRouter.log) then
   echo
   echo -------------------- Production Router ---------------------
   tail -$LINES $LOG/PRouter.log
endif
echo
ls $LOG/Dealer.*.log >& /dev/null
if ($status != 0) exit 0
foreach dealer ($LOG/Dealer.*.log)
   set queue = `echo "$dealer" | cut -d'.' -f2`
   echo ------------------- Dealer $queue ------------------------
   head -1 $dealer 
   set t = `tail -1 "$dealer"`
   set tt = `echo "$t" | cut -d' ' -f1-3`
   if("$tt" == "Dealer execution completed") then
     echo $t
   else
      tail -$LINES $dealer 
   endif
   echo
end
