#!/bin/csh

#****************************************************************************
# CheckReceiver.csh                                                 R Moulton
# This script will check to make shure the dicom reciver "simple_storage" is
# running, and if not, restart it.  This script is designed to be run
# periodically from the crontable for spectrum
#****************************************************************************
set S = $SNAME

if (`whoami` != spectrum) then
   echo Must be user spectrum to bounce dicom receiver
   exit 1
endif

set T1 = $TMP/CheckReceiver1

#------------------------------------list of running processes (newest first)
set PROCESS = `ps -ae -o ppid,pid,args | grep -v grep | grep simple_stor | sort | head -1`
if ("$PROCESS" != "") then 
   if ($PROCESS[1] == 1) exit 0
endif

#--------------------------------------------------------------------- Restart
$BIN/StartReceiver.csh 

#---------------------------------------------------------------- page message
cp $BIN/CheckReceiver.hdr $T1
echo "Restart $SNAME" >> $T1
$BIN/SendAlert $T1
rm $T1

#----------------------------------------------------------------- Log restart
echo "restarted `date`" >> $LOG/CheckReceiver.log

exit 0
