#!/bin/csh
#********************************************************************
# Runs df -k, grepping for parameter 1.  If one line returns, looks
# in that line for the % full figure and alerts if it is greater
# than the value in parameter 2.
# Logs alerted events, and all events if parameter 3 is "All".
#********************************************************************
# 2008 Aug 18 M.Suchko Remove percent sign from message except where
#             it is to be translated by the rcving program. Percent
#             is part of a variable definition.
# 2008 Dec 23 M.Suchko Fix problem when NFS drives not mounted.
# 2009 Jun 29 M.Suchko Clean out todelete directory when over 90%
#********************************************************************
# Delete todelete subdirectories when disk usage is above this percentage.
set LIMIT = 90
set T = $TMP/DiskCheck.tmp
set T2 = $TMP/DiskCheck2.tmp
set H = $BIN/DiskCheck.hdr
set L = $LOG/DiskCheck.log

set A = `df -k "$1" | grep "$1" | cat -n | tail -1`
if ("$A" == "") exit 1
if ("$A[1]" != "1") exit 2
set B = `echo "$A[6]" | cut -d'%' -f1`

if ($B <= $2) then
   if ("$3" == "All") echo "`date` $B%" >> $L
   exit 0
endif

echo "`date` $B%" >> $L

echo " " > $T2
if ($B > $LIMIT) then
   echo "Above $LIMIT percent. Program is removing todelete subdirectories now." > $T2
   echo "Above $LIMIT%. Removing todelete directories." >> $L
   rm -fr $IMGS/todelete/*
endif

echo "e=suchkom@mir.wustl.edu" > $T
#echo "e=3145388960@myairmail.com" >> $T
echo "t=Disk Check" >> $T
echo "d=%x %X" >> $T
if (-e $H) cp $H $T
echo "$SNAME" >> $T
echo "at $A[6]" | nawk '{gsub("\%"," percent",$0); print $0}' >> $T
cat $T2 >> $T
$BIN/SendAlert $T
exit 3
