#!/bin/csh

#*******************************************************************
# DumpBroadcastAttributes.csh    R Moulton, from a script by S Moore
#
# This script dumps a few attributes from a set of images.  These
# are used for logging of the broadcast task.  The parameters are
# the bin directory, used to find dcm_dump_file, and the images.
#-------------------------------------------------------------------
# 11-14-01 R Moulton - Added param for bin directory
#*******************************************************************

#-------------------------------------- Get location of dump program
set BIN = $1/dcm_dump_file
shift

#--------------------- Pull demographics info from one of the images
$BIN $1 | egrep "0010 0010|0010 0020|0008 0050|0008 0060"

#-------------------------------------------------- Count the images
@ count = 0
while ($1 != "")
   @ count += 1
   shift
end

#----------------------------------------- Output # & size of images
echo $count images and Kbytes: `du -sk .`

exit 0
