#!/bin/csh
#------------------------------------------------------------------------------ 
# Script to pull data from studies which are failing on distributor. $1 is the
# dest.*.sendto file, (from find). $2 is the number of failures which will
# trigger inclusion in Fail log (def 5).
#------------------------------------------------------------------------------
set DFILE = $1
set MAX = $2
set T1 = $TMP/Fail.tmp1
set T2 = $TMP/Fail.tmp2
#----------------------- Pull number of fails from dest file and compare to max
set FAILS = `cat "$DFILE" | cut -d',' -f5`
if ($FAILS < $MAX) exit 0
#-------------------------------------- Not in problems or todelete directories
set DIR = `echo "$DFILE" | cut -d'/' -f2`
if ($DIR == problems || $DIR == todelete) exit 0
#------------------------------------- Must still have images (not be complete)
set STUDY = `echo "$DFILE" | cut -d'/' -f2-4`
ls /distributor/imgs/$STUDY/*/* >& $T2 
if ($status == 1) exit 0
#--------------------------------------------- Pull tags from one of the images 
set image = `cat "$T2" | tail -1`
$BIN/dcm_dump_file $image | egrep "0010 0010|0010 0020|0008 0050" > $T1
set PNAME = `cat "$T1" | grep '0010 0010' | cut -d'/' -f5`
set PID   = `cat "$T1" | grep '0010 0020' | cut -d'/' -f5`
set ACCN  = `cat "$T1" | grep '0008 0050' | cut -d'/' -f5`
set DEST = `echo "$DFILE" | cut -d'/' -f5 | cut -d'.' -f2`
#----------------------------------------------------------- Generate log entry
echo "$FAILS	$DEST	$SNAME	$ACCN	$PID	$PNAME	$STUDY" >> $LOG/Fail.log
exit 0
