#!/bin/csh
#********************************************************************************
# MagicStoreStat.csh                                                    R Moulton
# script logs into mspds/msrd#'s and retrieves process status list, which it then
# processes to generate a log and optional e-mail and pager alerts
#********************************************************************************
#-------------------------------------------------- Must be logged in as spectrum
if (`whoami` != "spectrum") then
   echo "Must be user spectrum to run Dealer"
   exit 1
endif

set SRVR = "mspds"
if ("$1" != "") set SRVR = "$1"
if ("$SRVR" != "mspds" && "$SRVR" != "msrd1" && "$SRVR" != "msrd2" && "$SRVR" != "msrd3" && "$SRVR" != "msrd4" && "$SRVR" != "msrd5") then
   echo "Usage: MagicStoreStat.csh [mspds|msrd1|msrd2|msrd3|msrd4|msrd5]"
   exit 1
endif

set T1 = $TMP/${SRVR}Stat.tmp
set DLG = $TMP/${SRVR}Stat.dlg

echo '#\!/usr/local/bin/expect' > $DLG
echo "spawn telnet $SRVR" >> $DLG
echo 'expect "login: "' >> $DLG
echo 'send "priv\r"' >> $DLG
echo 'expect "Password: "' >> $DLG
echo 'send "priv\r"' >> $DLG
echo 'expect "/n): "' >> $DLG
echo 'send "y\r"' >> $DLG
echo 'expect "Info"' >> $DLG
echo 'send "1\r"' >> $DLG
echo 'expect "States"' >> $DLG
echo 'send "1\r"' >> $DLG
echo 'expect "Process List"' >> $DLG
echo "log_file -a $T1" >> $DLG
echo 'expect "States"' >> $DLG
if ("$SRVR" != "mspds") then
   echo 'send "\033\[6~"' >> $DLG
   echo 'expect "States"' >> $DLG
endif
echo 'log_file' >> $DLG
echo 'send "7\r"' >> $DLG
echo 'expect "Info"' >> $DLG
echo 'send "6\r"' >> $DLG

if (-e $T1) rm $T1
chmod 755 $DLG
$DLG > /dev/null
rm $DLG

if (-e $T1) then
   $BIN/MagicStoreStat $SRVR 
   rm $T1
endif

exit 0
