#!/bin/csh
#******************************************************************************
# Ping.csh                                                            R Moulton
# Script to perform dicom echo on destination from some distributor, using the
# information in the MIRCS_dicom_broadcast.ini file.  Calling format:
#    Ping.csh DEST_CODE
#------------------------------------------------------------------------------
# 12-12-05 R Moulton - Initial write
#******************************************************************************
cd $BIN

set DEST = "$1"
if ("$DEST" == "") set DEST = "IMG6"
#----------------------------------------- DLINE is "DEST_CODE=server|AE title"
set DLINE = `grep "^$DEST=" MIRCS_dicom_broadcast.ini | cut -d'#' -f1`
if ($status != 0) then
   echo "$DEST not set up"
   exit 1
endif
#------------------------------------------------------- A is "server|AE title"
set A = `echo $DLINE | cut -d'=' -f2`

set SRVR = `echo $A | cut -d'|' -f1`
if ("$SRVR" == "") then
   echo "No server name set up"
   exit 1
endif
#----------------------------------- AE title.  If blank, DEST_CODE is AE title
set AE = `echo $A | cut -d'|' -f2`
if ("$AE" == "") set AE = "$DEST"

#--------------------------------------------- SLINE is "server=IPaddress:port"
set SLINE = `grep "^$SRVR=" MIRCS_dicom_broadcast.ini | cut -d'#' -f1`
if ($status != 0) then
   echo "destination server not set up"
   exit 1
endif
#------------------------------------------------------- B is "IP address:port"
set B = `echo $SLINE | cut -d'=' -f2`

set IP = `echo $B | cut -d':' -f1`
if ("$IP" == "") then
   echo "No IP address defined"
   exit 1
endif

set PORT = `echo $SLINE | cut -d':' -f2`
if ("$PORT" == "") then
   echo "No port defined"
   exit 1
endif

echo "DICOM echo $DEST"
echo "========================"
dicom_echo -a $AE -c $SRVR $IP $PORT
