#!/bin/csh
#***********************************************************************
# PurgeNULL.csh                                                R Moulton
#
# This script deletes a study.  It is called by Janitor.csh when a study
# is found which has the dest.NULL.sendto routing.  1st parameter is the 
# path name of the dest.NULL.sendto file, which is double checked for
# existence before deleting the study.
# 
# PurgeNULL.csh studydir/dest.NULL.sendto stopfile logfile
#-----------------------------------------------------------------------
#***********************************************************************

set DESTFILE = $1
set STOP = $2
set LOG = $3
if (!(-e $DESTFILE)) exit 1
if (-e $STOP) exit 1

#----------------- Pull the study directory path name from the file name
@ cp = `echo "$DESTFILE" | wc -c` - `echo "/dest.NULL.sendto" | wc -c`
set PTH = `echo "$DESTFILE" | cut -c1-$cp`

#--------------------------------------------------------- clear and log
rm -r $PTH
echo "   $PTH NULL routed study purged" >> $LOG

exit 0

