#!/bin/csh

#***********************************************************************
# QCheck.csh                                                   R Moulton
#
# Checks status of production dicom broadcast queue, using broadcast
# logs.  Command format:
#
# QCheck.csh servername queuename lines
#-----------------------------------------------------------------------
# 9-12-2 R Moulton - Modified to use home env var
#***********************************************************************
set S = $SNAME   
set Q = bond1
if ("$1" != "") set Q = "$1"
set LINES = 4 
if ($2 != "") set LINES = $2
set LOG = $HOME/production/$S/log
set TMP = $HOME/production/$S/tmp
set dealer = $LOG/Dealer.$Q.log
if (!(-e $dealer)) then
   echo "$dealer file not found"
   exit 1
endif
echo ====================================================================
echo "Distributor status for queue $Q `date`"
echo ====================================================================
echo "------------- scripts locked & stopped --------------------"
cd $TMP
ls Dealer.csh.lock.$Q *stop* 
echo
ls $dealer >& /dev/null
if ($status != 0) exit 0
echo ------------------- Dealer $Q ------------------------
head -1 $dealer 
tail -$LINES $dealer 
echo
exit 0
