#!/bin/csh
#***********************************************************
# Handles possibility of multiple queue routing for studies 
# $1 = source directory, $2 = modality directory,
# $3 = config file, $4 = bump flag (YES, anything else)
#***********************************************************
#- Find out how many routings for this source modality exist
set COUNT = `grep -c "^$1,$2" $3`
#------ None, exit status 1 indicates no routing takes place
if ($COUNT == 0) exit (1)
#------------------ One; echo routing and exit with status 0
if ($COUNT == 1) then
   grep "^$1,$2" $3
   exit (0)
endif
#-----------------------------------------------------------
# More than one.  We maintain a NextQueue file in the source
# modality directory, indicating which routing should be the
# next one used, bumping it each time.
#-----------------------------------------------------------
set Q = /distributor/imgs/$1/$2/NextQueue
set NEXT = 1
if (-e $Q) set NEXT = "`cat $Q`"
if ($NEXT > $COUNT) set NEXT = 1
grep "^$1,$2" $3 | tail +$NEXT | head -1
if ("$4" == "YES") then
   @ NEXT += 1
   if ($NEXT > $COUNT) then
      @ NEXT = 1
   endif
   echo $NEXT > $Q
endif
exit (2)
