#!/bin/csh
#***********************************************************************
# StartReceiver.csh                                              S Moore
#
# Starts dicom receiver. Invocation: StartReceiver.csh servername
#-----------------------------------------------------------------------
# 3-7-2 R Moulton Added user check and check to make sure it wasn't
#                 already running
# 08-30-02 R Moulton - Modified to add relay1 and relay2
#***********************************************************************
set T1 = $IMGS/StartReceiver.tmp1

#------------------------------------------------- Must be user spectrum
if (`whoami` != spectrum) then
   echo "Must be user spectrum"
   exit 1
endif

#-------------------------------------------------- Validate, cap server
set S = $ACSNAME

#---------------------------------------------- Make sure images dir exists
if (!(-d $IMGS)) then
   echo "Directory $IMGS not found"
   exit 1
endif

#-------------------------------------------- Make sure not already running
ps -aef > $T1
grep simple_stor $T1 >& /dev/null
set st = $status
rm $T1
if ($st == 0) then
   echo "Dicom receiver already running"
   exit 1
endif

#----------------------------------------------------------- Start receiver
umask 002
cd $IMGS
#/usr/local/ctn/bin/simple_store -t -1 -f -s -i -c $ACSNAME -n /usr/local/acq/ctn/storage.convention 104 >& $LOG/MIRCS_simple_storage.log  &
/usr/local/ctn/bin/simple_store -t -1 -f -s -i -c $ACSNAME -n /usr/local/acq/ctn/storage.convention 104 >& /dev/null  &
exit 0
