#!/bin/csh

#********************************************************************
# XmitsOK.csh                                               R Moulton
#
# This script examines lines grepped from .broadcast.rslt files, 
# for a single image, which are in a file which is standard input, 
# and determines if all of them represent successful dicom transmits.
# If so, it returns a status of 0, otherwise it returns a status of 1
# There will be only one image represented in the file, but there may
# be multiple destinations and multiple attempts to each destination.
# The last attempt to a destination will have a zero status if the 
# transmit was successful.  There will be lines in the file.
#********************************************************************
set dests = ""
set stats = ""
@ next = 1
while (1)   
   set input = $<
   if ("$input" == "") break
   set dest = `echo "$input" | cut -d'^' -f2`
   set stat = `echo "$input" | cut -d'^' -f4`
   @ i = 1
   while (1)           
#--------------------------------------- Add new destination to list
      if ($i == $next) then
         set dests = ($dests "$dest")
         set stats = ($stats 1)
         @ next += 1
      endif
#------------------------------------------ This isn't the right one
      if ("$dests[$i]" != "$dest") then
         @ i += 1
         continue
      endif
#--------------------------------------------- This is the right one
      @ stats[$i] = 1
      if ("$stat" == "0") @ stats[$i] = 0
      break
   end
end
#------------------------------------- Return 1 if any one's in stat
echo "$stats" | grep 1 >& /dev/null
if ($status == 0) exit 1
exit 0
