# Find errors and report by station.
# M.Suchko	2008 Aug 20
BEGIN	{
   OFS="\t"
   FS="\t"
   OFMT="%.1g"
#   "uname -n" | getline distributorName
}
# Main
{

if (NR == FNR)
{
FS="\t"
# Read in the file of stations by facility and group.
# NOTE: A station CAN BE IN MORE THAN ONE QC_GROUP
   if ($1 != "" && $2 != "" && $3 != "")
      {
      sttnNm=toupper($3)
      listOfFacilities[$1]=$1

      listOfQc_groups[$2]=$2

      stationInGroup[$2,sttnNm]="Y"
      stationInFacility[$1,sttnNm]="Y"
      stationDescription[sttnNm]=$4
      }
}

if (NR != FNR)
{
FS=" "
if ($0 ~ /   Study received from /)
   {
   applicationEntity=$4
   }
# Examine the errors.
else if (match($0,"^   [A-Za-z]"))
   {
   if (match($0,"^   RAD query failed"))
      {
      ignoreError="Y"
      }
   else
      {
      errorFound="Y"
      }
   }
else if ( match($0,"^=+$") )
   {
   if (studyCounted[studyUID,studyDate] != "Y")
      {
      studyCountByStationName[stationName,studyDate]++
      studyCounted[studyUID,studyDate]="Y"
      }
   if (ignoreError != "Y" && errorFound == "Y" && errorOnStudy[studyUID,studyDate] != "Y")
      {
      errorMessageCtr[stationName,studyDate]++
      errorOnStudy[studyUID,studyDate]="Y"
      }
# Clear variables.
   ignoreError=""
   errorFound=""
   }
else
   {
# Harvest the DICOM header info
keyWord=substr($0,7,12)
sub(/[ ]+$/,"",keyWord)
if (keyWord == "station name")
   {
   zzz=substr($0,20)
   gsub(/[ ]+$/,"",zzz)
   stationName=toupper(zzz)
#print "DEBUG77>" zzz "><" stationName "><" stationDescription[stationName] ">"
   if (stationName == "")
      {
      displayStationName[stationName]=applicationEntity
      }
   else if (stationDescription[stationName] != "")
      {
      displayStationName[stationName]=stationDescription[stationName]
      }
   else
      {
      displayStationName[stationName]=zzz
      }

   listOfStationNames[stationName]="Y"
   applicationEntityByStationName[stationName]=applicationEntity
   }
else if (keyWord == "study date")
   {
   studyDate=$3
   listOfStudyDates[studyDate]="Y"
   }
else if (keyWord == "study UID")
   {
   studyUID=$3
   }
   }
}
}
END	{
for (aStationName in listOfStationNames)
   {
#      for (studyDate in listOfStudyDates)
      studyDate=yesterDay
#print "DEBUG4>" aStationName "><" anErrorMessage "><" studyDate "><" errorMessageCtr[aStationName,studyUID,studyDate] ">"
      if (errorMessageCtr[aStationName,studyDate])
         {
            print displayStationName[aStationName],applicationEntityByStationName[aStationName],studyDate,errorMessageCtr[aStationName,studyDate],studyCountByStationName[aStationName,studyDate],(errorMessageCtr[aStationName,studyDate]/studyCountByStationName[aStationName,studyDate])
         }
   }
}
