# tab2htmlSort.awk
# M.Suchko	2008 July 31
#
BEGIN	{
  FS = "\t";

  print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">";
  print "<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en-US\" xml:lang=\"en-US\">";
  print "<head>";
  print "  <meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\" />";

  print "<script type=\"text/javascript\">"
  print "var stIsIE = /*@cc_on!@*/false;"
  print ""
  print "sorttable = {"
  print "  init: function() {"
  print "    // quit if this function has already been called"
  print "    if (arguments.callee.done) return;"
  print "    // flag this function so we don't do the same thing twice"
  print "    arguments.callee.done = true;"
  print "    // kill the timer"
  print "    if (_timer) clearInterval(_timer);"
  print "    "
  print "    if (!document.createElement || !document.getElementsByTagName) return;"
  print "    "
  print "    sorttable.DATE_RE = /^(\d\d?)[\/\.-](\d\d?)[\/\.-]((\d\d)?\d\d)$/;"
  print "    "
  print "    forEach(document.getElementsByTagName('table'), function(table) {"
  print "      if (table.className.search(/\\bsortable\\b/) != -1) {"
  print "        sorttable.makeSortable(table);"
  print "      }"
  print "    });"
  print "    "
  print "  },"
  print "  "
  print "  makeSortable: function(table) {"
  print "    if (table.getElementsByTagName('thead').length == 0) {"
  print "      // table doesn't have a tHead. Since it should have, create one and"
  print "      // put the first table row in it."
  print "      the = document.createElement('thead');"
  print "      the.appendChild(table.rows[0]);"
  print "      table.insertBefore(the,table.firstChild);"
  print "    }"
  print "    // Safari doesn't support table.tHead, sigh"
  print "    if (table.tHead == null) table.tHead = table.getElementsByTagName('thead')[0];"
  print "    "
  print "    if (table.tHead.rows.length != 1) return; // can't cope with two header rows"
  print "    "
  print "    // Sorttable v1 put rows with a class of \"sortbottom\" at the bottom (as"
  print "    // \"total\" rows, for example). This is B&R, since what you're supposed"
  print "    // to do is put them in a tfoot. So, if there are sortbottom rows,"
  print "    // for backwards compatibility, move them to tfoot (creating it if needed)."
  print "    sortbottomrows = [];"
  print "    for (var i=0; i<table.rows.length; i++) {"
  print "      if (table.rows[i].className.search(/\\bsortbottom\\b/) != -1) {"
  print "        sortbottomrows[sortbottomrows.length] = table.rows[i];"
  print "      }"
  print "    }"
  print "    if (sortbottomrows) {"
  print "      if (table.tFoot == null) {"
  print "        // table doesn't have a tfoot. Create one."
  print "        tfo = document.createElement('tfoot');"
  print "        table.appendChild(tfo);"
  print "      }"
  print "      for (var i=0; i<sortbottomrows.length; i++) {"
  print "        tfo.appendChild(sortbottomrows[i]);"
  print "      }"
  print "      delete sortbottomrows;"
  print "    }"
  print "    "
  print "    // work through each column and calculate its type"
  print "    headrow = table.tHead.rows[0].cells;"
  print "    for (var i=0; i<headrow.length; i++) {"
  print "      // manually override the type with a sorttable_type attribute"
  print "      if (!headrow[i].className.match(/\\bsorttable_nosort\\b/)) { // skip this col"
  print "        mtch = headrow[i].className.match(/\\bsorttable_([a-z0-9]+)\\b/);"
  print "        if (mtch) { override = mtch[1]; }"
  print "	      if (mtch && typeof sorttable[\"sort_\"+override] == 'function') {"
  print "	        headrow[i].sorttable_sortfunction = sorttable[\"sort_\"+override];"
  print "	      } else {"
  print "	        headrow[i].sorttable_sortfunction = sorttable.guessType(table,i);"
  print "	      }"
  print "	      // make it clickable to sort"
  print "	      headrow[i].sorttable_columnindex = i;"
  print "	      headrow[i].sorttable_tbody = table.tBodies[0];"
  print "	      dean_addEvent(headrow[i],\"click\", function(e) {"
  print ""
  print "          if (this.className.search(/\\bsorttable_sorted\\b/) != -1) {"
  print "            // if we're already sorted by this column, just "
  print "            // reverse the table, which is quicker"
  print "            sorttable.reverse(this.sorttable_tbody);"
  print "            this.className = this.className.replace('sorttable_sorted',"
  print "                                                    'sorttable_sorted_reverse');"
  print "            this.removeChild(document.getElementById('sorttable_sortfwdind'));"
  print "            sortrevind = document.createElement('span');"
  print "            sortrevind.id = \"sorttable_sortrevind\";"
  print "            sortrevind.innerHTML = stIsIE ? '&nbsp<font face=\"webdings\">5</font>' : '&nbsp;&#x25B4;';"
  print "            this.appendChild(sortrevind);"
  print "            return;"
  print "          }"
  print "          if (this.className.search(/\\bsorttable_sorted_reverse\\b/) != -1) {"
  print "            // if we're already sorted by this column in reverse, just "
  print "            // re-reverse the table, which is quicker"
  print "            sorttable.reverse(this.sorttable_tbody);"
  print "            this.className = this.className.replace('sorttable_sorted_reverse',"
  print "                                                    'sorttable_sorted');"
  print "            this.removeChild(document.getElementById('sorttable_sortrevind'));"
  print "            sortfwdind = document.createElement('span');"
  print "            sortfwdind.id = \"sorttable_sortfwdind\";"
  print "            sortfwdind.innerHTML = stIsIE ? '&nbsp<font face=\"webdings\">6</font>' : '&nbsp;&#x25BE;';"
  print "            this.appendChild(sortfwdind);"
  print "            return;"
  print "          }"
  print "          "
  print "          // remove sorttable_sorted classes"
  print "          theadrow = this.parentNode;"
  print "          forEach(theadrow.childNodes, function(cell) {"
  print "            if (cell.nodeType == 1) { // an element"
  print "              cell.className = cell.className.replace('sorttable_sorted_reverse','');"
  print "              cell.className = cell.className.replace('sorttable_sorted','');"
  print "            }"
  print "          });"
  print "          sortfwdind = document.getElementById('sorttable_sortfwdind');"
  print "          if (sortfwdind) { sortfwdind.parentNode.removeChild(sortfwdind); }"
  print "          sortrevind = document.getElementById('sorttable_sortrevind');"
  print "          if (sortrevind) { sortrevind.parentNode.removeChild(sortrevind); }"
  print "          "
  print "          this.className += ' sorttable_sorted';"
  print "          sortfwdind = document.createElement('span');"
  print "          sortfwdind.id = \"sorttable_sortfwdind\";"
  print "          sortfwdind.innerHTML = stIsIE ? '&nbsp<font face=\"webdings\">6</font>' : '&nbsp;&#x25BE;';"
  print "          this.appendChild(sortfwdind);"
  print ""
  print "	        // build an array to sort. This is a Schwartzian transform thing,"
  print "	        // i.e., we \"decorate\" each row with the actual sort key,"
  print "	        // sort based on the sort keys, and then put the rows back in order"
  print "	        // which is a lot faster because you only do getInnerText once per row"
  print "	        row_array = [];"
  print "	        col = this.sorttable_columnindex;"
  print "	        rows = this.sorttable_tbody.rows;"
  print "	        for (var j=0; j<rows.length; j++) {"
  print "	          row_array[row_array.length] = [sorttable.getInnerText(rows[j].cells[col]), rows[j]];"
  print "	        }"
  print "	        /* If you want a stable sort, uncomment the following line */"
  print "	        //sorttable.shaker_sort(row_array, this.sorttable_sortfunction);"
  print "	        /* and comment out this one */"
  print "	        row_array.sort(this.sorttable_sortfunction);"
  print "	        "
  print "	        tb = this.sorttable_tbody;"
  print "	        for (var j=0; j<row_array.length; j++) {"
  print "	          tb.appendChild(row_array[j][1]);"
  print "	        }"
  print "	        "
  print "	        delete row_array;"
  print "	      });"
  print "	    }"
  print "    }"
  print "  },"
  print "  "
  print "  guessType: function(table, column) {"
  print "    // guess the type of a column based on its first non-blank row"
  print "    sortfn = sorttable.sort_alpha;"
  print "    for (var i=0; i<table.tBodies[0].rows.length; i++) {"
  print "      text = sorttable.getInnerText(table.tBodies[0].rows[i].cells[column]);"
  print "      if (text != '') {"
  print "        if (text.match(/^-?[$]?[\d,.]+%?$/)) {"
  print "          return sorttable.sort_numeric;"
  print "        }"
  print "        // check for a date: dd/mm/yyyy or dd/mm/yy "
  print "        // can have / or . or - as separator"
  print "        // can be mm/dd as well"
  print "        possdate = text.match(sorttable.DATE_RE)"
  print "        if (possdate) {"
  print "          // looks like a date"
  print "          first = parseInt(possdate[1]);"
  print "          second = parseInt(possdate[2]);"
  print "          if (first > 12) {"
  print "            // definitely dd/mm"
  print "            return sorttable.sort_ddmm;"
  print "          } else if (second > 12) {"
  print "            return sorttable.sort_mmdd;"
  print "          } else {"
  print "            // looks like a date, but we can't tell which, so assume"
  print "            // that it's dd/mm (English imperialism!) and keep looking"
  print "            sortfn = sorttable.sort_ddmm;"
  print "          }"
  print "        }"
  print "      }"
  print "    }"
  print "    return sortfn;"
  print "  },"
  print "  "
  print "  getInnerText: function(node) {"
  print "    // gets the text we want to use for sorting for a cell."
  print "    // strips leading and trailing whitespace."
  print "    // this is *not* a generic getInnerText function; it's special to sorttable."
  print "    // for example, you can override the cell text with a customkey attribute."
  print "    // it also gets .value for <input> fields."
  print "    "
  print "    hasInputs = (typeof node.getElementsByTagName == 'function') &&"
  print "                 node.getElementsByTagName('input').length;"
  print "    "
  print "    if (node.getAttribute(\"sorttable_customkey\") != null) {"
  print "      return node.getAttribute(\"sorttable_customkey\");"
  print "    }"
  print "    else if (typeof node.textContent != 'undefined' && !hasInputs) {"
  print "      return node.textContent.replace(/^\s+|\s+$/g, '');"
  print "    }"
  print "    else if (typeof node.innerText != 'undefined' && !hasInputs) {"
  print "      return node.innerText.replace(/^\s+|\s+$/g, '');"
  print "    }"
  print "    else if (typeof node.text != 'undefined' && !hasInputs) {"
  print "      return node.text.replace(/^\s+|\s+$/g, '');"
  print "    }"
  print "    else {"
  print "      switch (node.nodeType) {"
  print "        case 3:"
  print "          if (node.nodeName.toLowerCase() == 'input') {"
  print "            return node.value.replace(/^\s+|\s+$/g, '');"
  print "          }"
  print "        case 4:"
  print "          return node.nodeValue.replace(/^\s+|\s+$/g, '');"
  print "          break;"
  print "        case 1:"
  print "        case 11:"
  print "          var innerText = '';"
  print "          for (var i = 0; i < node.childNodes.length; i++) {"
  print "            innerText += sorttable.getInnerText(node.childNodes[i]);"
  print "          }"
  print "          return innerText.replace(/^\s+|\s+$/g, '');"
  print "          break;"
  print "        default:"
  print "          return '';"
  print "      }"
  print "    }"
  print "  },"
  print "  "
  print "  reverse: function(tbody) {"
  print "    // reverse the rows in a tbody"
  print "    newrows = [];"
  print "    for (var i=0; i<tbody.rows.length; i++) {"
  print "      newrows[newrows.length] = tbody.rows[i];"
  print "    }"
  print "    for (var i=newrows.length-1; i>=0; i--) {"
  print "       tbody.appendChild(newrows[i]);"
  print "    }"
  print "    delete newrows;"
  print "  },"
  print "  "
  print "  /* sort functions"
  print "     each sort function takes two parameters, a and b"
  print "     you are comparing a[0] and b[0] */"
  print "  sort_numeric: function(a,b) {"
  print "    aa = parseFloat(a[0].replace(/[^0-9.-]/g,''));"
  print "    if (isNaN(aa)) aa = 0;"
  print "    bb = parseFloat(b[0].replace(/[^0-9.-]/g,'')); "
  print "    if (isNaN(bb)) bb = 0;"
  print "    return aa-bb;"
  print "  },"
  print "  sort_alpha: function(a,b) {"
  print "    if (a[0]==b[0]) return 0;"
  print "    if (a[0]<b[0]) return -1;"
  print "    return 1;"
  print "  },"
  print "  sort_ddmm: function(a,b) {"
  print "    mtch = a[0].match(sorttable.DATE_RE);"
  print "    y = mtch[3]; m = mtch[2]; d = mtch[1];"
  print "    if (m.length == 1) m = '0'+m;"
  print "    if (d.length == 1) d = '0'+d;"
  print "    dt1 = y+m+d;"
  print "    mtch = b[0].match(sorttable.DATE_RE);"
  print "    y = mtch[3]; m = mtch[2]; d = mtch[1];"
  print "    if (m.length == 1) m = '0'+m;"
  print "    if (d.length == 1) d = '0'+d;"
  print "    dt2 = y+m+d;"
  print "    if (dt1==dt2) return 0;"
  print "    if (dt1<dt2) return -1;"
  print "    return 1;"
  print "  },"
  print "  sort_mmdd: function(a,b) {"
  print "    mtch = a[0].match(sorttable.DATE_RE);"
  print "    y = mtch[3]; d = mtch[2]; m = mtch[1];"
  print "    if (m.length == 1) m = '0'+m;"
  print "    if (d.length == 1) d = '0'+d;"
  print "    dt1 = y+m+d;"
  print "    mtch = b[0].match(sorttable.DATE_RE);"
  print "    y = mtch[3]; d = mtch[2]; m = mtch[1];"
  print "    if (m.length == 1) m = '0'+m;"
  print "    if (d.length == 1) d = '0'+d;"
  print "    dt2 = y+m+d;"
  print "    if (dt1==dt2) return 0;"
  print "    if (dt1<dt2) return -1;"
  print "    return 1;"
  print "  },"
  print "  "
  print "  shaker_sort: function(list, comp_func) {"
  print "    // A stable sort function to allow multi-level sorting of data"
  print "    // see: http://en.wikipedia.org/wiki/Cocktail_sort"
  print "    var b = 0;"
  print "    var t = list.length - 1;"
  print "    var swap = true;"
  print ""
  print "    while(swap) {"
  print "        swap = false;"
  print "        for(var i = b; i < t; ++i) {"
  print "            if ( comp_func(list[i], list[i+1]) > 0 ) {"
  print "                var q = list[i]; list[i] = list[i+1]; list[i+1] = q;"
  print "                swap = true;"
  print "            }"
  print "        } // for"
  print "        t--;"
  print ""
  print "        if (!swap) break;"
  print ""
  print "        for(var i = t; i > b; --i) {"
  print "            if ( comp_func(list[i], list[i-1]) < 0 ) {"
  print "                var q = list[i]; list[i] = list[i-1]; list[i-1] = q;"
  print "                swap = true;"
  print "            }"
  print "        } // for"
  print "        b++;"
  print ""
  print "    } // while(swap)"
  print "  }  "
  print "}"
  print ""
  print "/* ******************************************************************"
  print "   Supporting functions: bundled here to avoid depending on a library"
  print "   ****************************************************************** */"
  print ""
  print "/* for Mozilla/Opera9 */"
  print "if (document.addEventListener) {"
  print "    document.addEventListener(\"DOMContentLoaded\", sorttable.init, false);"
  print "}"
  print ""
  print "/* for Internet Explorer */"
  print "/*@cc_on @*/"
  print "/*@if (@_win32)"
  print "    document.write(\"<script id=__ie_onload defer src=javascript:void(0)><\\/script>\");"
  print "    var script = document.getElementById(\"__ie_onload\");"
  print "    script.onreadystatechange = function() {"
  print "        if (this.readyState == \"complete\") {"
  print "            sorttable.init(); // call the onload handler"
  print "        }"
  print "    };"
  print "/*@end @*/"
  print ""
  print "/* for Safari */"
  print "if (/WebKit/i.test(navigator.userAgent)) { // sniff"
  print "    var _timer = setInterval(function() {"
  print "        if (/loaded|complete/.test(document.readyState)) {"
  print "            sorttable.init(); // call the onload handler"
  print "        }"
  print "    }, 10);"
  print "}"
  print ""
  print "/* for other browsers */"
  print "window.onload = sorttable.init;"
  print ""
  print "function dean_addEvent(element, type, handler) {"
  print "	if (element.addEventListener) {"
  print "		element.addEventListener(type, handler, false);"
  print "	} else {"
  print "		// assign each event handler a unique ID"
  print "		if (!handler.$$guid) handler.$$guid = dean_addEvent.guid++;"
  print "		// create a hash table of event types for the element"
  print "		if (!element.events) element.events = {};"
  print "		// create a hash table of event handlers for each element/event pair"
  print "		var handlers = element.events[type];"
  print "		if (!handlers) {"
  print "			handlers = element.events[type] = {};"
  print "			// store the existing event handler (if there is one)"
  print "			if (element[\"on\" + type]) {"
  print "				handlers[0] = element[\"on\" + type];"
  print "			}"
  print "		}"
  print "		// store the event handler in the hash table"
  print "		handlers[handler.$$guid] = handler;"
  print "		// assign a global event handler to do all the work"
  print "		element[\"on\" + type] = handleEvent;"
  print "	}"
  print "};"
  print "// a counter used to create unique IDs"
  print "dean_addEvent.guid = 1;"
  print ""
  print "function removeEvent(element, type, handler) {"
  print "	if (element.removeEventListener) {"
  print "		element.removeEventListener(type, handler, false);"
  print "	} else {"
  print "		// delete the event handler from the hash table"
  print "		if (element.events && element.events[type]) {"
  print "			delete element.events[type][handler.$$guid];"
  print "		}"
  print "	}"
  print "};"
  print ""
  print "function handleEvent(event) {"
  print "	var returnValue = true;"
  print "	// grab the event object (IE uses a global event object)"
  print "	event = event || fixEvent(((this.ownerDocument || this.document || this).parentWindow || window).event);"
  print "	// get a reference to the hash table of event handlers"
  print "	var handlers = this.events[event.type];"
  print "	// execute each event handler"
  print "	for (var i in handlers) {"
  print "		this.$$handleEvent = handlers[i];"
  print "		if (this.$$handleEvent(event) === false) {"
  print "			returnValue = false;"
  print "		}"
  print "	}"
  print "	return returnValue;"
  print "};"
  print ""
  print "function fixEvent(event) {"
  print "	// add W3C standard event methods"
  print "	event.preventDefault = fixEvent.preventDefault;"
  print "	event.stopPropagation = fixEvent.stopPropagation;"
  print "	return event;"
  print "};"
  print "fixEvent.preventDefault = function() {"
  print "	this.returnValue = false;"
  print "};"
  print "fixEvent.stopPropagation = function() {"
  print "  this.cancelBubble = true;"
  print "}"
  print ""
  print "// Dean's forEach: http://dean.edwards.name/base/forEach.js"
  print "/*"
  print "	forEach, version 1.0"
  print "	Copyright 2006, Dean Edwards"
  print "	License: http://www.opensource.org/licenses/mit-license.php"
  print "*/"
  print ""
  print "// array-like enumeration"
  print "if (!Array.forEach) { // mozilla already supports this"
  print "	Array.forEach = function(array, block, context) {"
  print "		for (var i = 0; i < array.length; i++) {"
  print "			block.call(context, array[i], i, array);"
  print "		}"
  print "	};"
  print "}"
  print ""
  print "// generic enumeration"
  print "Function.prototype.forEach = function(object, block, context) {"
  print "	for (var key in object) {"
  print "		if (typeof this.prototype[key] == \"undefined\") {"
  print "			block.call(context, object[key], key, object);"
  print "		}"
  print "	}"
  print "};"
  print ""
  print "// character enumeration"
  print "String.forEach = function(string, block, context) {"
  print "	Array.forEach(string.split(\"\"), function(chr, index) {"
  print "		block.call(context, chr, index, string);"
  print "	});"
  print "};"
  print ""
  print "// globally resolve forEach enumeration"
  print "var forEach = function(object, block, context) {"
  print "	if (object) {"
  print "		var resolve = Object; // default"
  print "		if (object instanceof Function) {"
  print "			// functions have a \"length\" property"
  print "			resolve = Function;"
  print "		} else if (object.forEach instanceof Function) {"
  print "			// the object implements a custom forEach method so use that"
  print "			object.forEach(block, context);"
  print "			return;"
  print "		} else if (typeof object == \"string\") {"
  print "			// the object is a string"
  print "			resolve = String;"
  print "		} else if (typeof object.length == \"number\") {"
  print "			// the object is array-like"
  print "			resolve = Array;"
  print "		}"
  print "		resolve.forEach(object, block, context);"
  print "	}"
  print "};"
  print "</script>"

  print "</head>";
  print "<style>";
  print "table.sortable {";
  print "  font-family: Verdana, Arial, Helvetica, Sans-Serif;";
  print "  font-size: 12px;";
  print "}";
  print "table.sortable caption {";
  print "  font-size: 18px;";
  print "}";
  print "table.sortable th {";
  print "  background-color: #CCCCCC;";
  print "  border-bottom: solid 1px #000000;";
  print "  border-right: solid 1px #000000;";
  print "}";
  print "table.sortable td {";
  print "  border-bottom: solid 1px #000000;";
  print "  border-right: solid 1px #000000;";
  print "}";
  print "</style>";
  print "<body bgcolor=#fff0f0>";
  print "<a name=\"TOP\"></a>"
}
{
  if (NR == 1)
     {
# Passed in parameters are not available in the "Begin" block.
     print "  <title>" title "</title>";
     }
}
