#!/bin/sh
# idqcLog.sh
# Copy yesterday's EQC log to NFS mounted space for later processing.
# 
# Michael Suchko	2008 Aug 20
. $HOME/.profile

execDir=$BIN

currentYear=`date '+%Y'`
currentMonth=`date '+%m'`
currentDay=`date '+%d'`

year=$currentYear
month=$currentMonth
day=$currentDay

# What day was yesterday?
    # if it is the first day of the month
    if [ $day -eq 01 ]
    then
       # if it is the first month of the year
       if [ $month -eq 01 ]
       then
           # make the month as 12
           month=12

           # deduct the year by one
           year=`expr $year - 1`
       else
           # deduct the month by one
           month=`expr $month - 1`
          if [ $month -lt 10 ]
          then
             mZero="0"
          fi
       fi

       day=`cal $month $year | awk 'NF != 0{ last = $NF }; END{ print last }'`
    else
       # deduct the day by one
       day=`expr $day - 1`
    fi

    if [ $day -lt 10 ]
    then
       dZero="0"
    fi

if [ $SNAME = "relay1" ]
then
   cp -p $LOG/EQC$year$mZero$month$dZero$day.log  $SHARED_DIR/EQC$year$mZero$month$dZero$day.$SNAME.log
   chmod a+rw $SHARED_DIR/EQC$year$mZero$month$dZero$day.$SNAME.log
else
   cp -p $LOG/EQC$year$mZero$month$dZero$day.log  /export/share/EQC$year$mZero$month$dZero$day.$SNAME.log
   chmod a+rw /export/share/EQC$year$mZero$month$dZero$day.$SNAME.log
fi

exit 0
