#!/bin/sh
# idqcReport.sh
# Take the QC log reports from all of the servers and produce an HTML report.
#
# 1st parameter - if "Mail" then e-mail the report.
# 
# Michael Suchko	2008 Oct 2
. $HOME/.profile
cd $BIN

# E-mail addresses ...
Ansel="mla5250@bjc.org"
Barnum="jlb5898@bjc.org"
Battle="rab3401@bjc.org"
Belcher="dxb8043@bjc.org"
Bishop="dmb2761@bjc.org"
Buffa="rbb6355@bjc.org"
Chaney=jjc3704@bjc.org
Crouse="arc1969@bjc.org"
Garcia="vmg5644@bjc.org"
Genetti="nag9591@bjc.org"
Hedgecorth="Jmh3108@bjc.org"
Hogan="mgh2714@bjc.org"
Lombardo="jbl4756@bjc.org"
Kay="mks8532@bjc.org"
Kleypas="KleypasD@mir.wustl.edu"
Melson="MelsonD@mir.wustl.edu"
Mirpacs="mirpacs@mir.wustl.edu"
Naes="jpn4735@bjc.org"
Oberholtzer="lao7530@bjc.org"
Onder="mro3328@bjc.org"
Pashia="PashiaR@mir.wustl.edu"
Picus="PicusD@mir.wustl.edu"
Rehagen=dmr9992@bjc.org
Renaud=sxr3177@bjc.org
Rhoden="jmr2112@bjc.org"
Rosen=slr2402@bjc.org
Silvestros="dks0577@bjc.org"
Sloan="tcs4747@bjc.org"
Stemmler="mks8532@bjc.org"
Suchko="SuchkoM@mir.wustl.edu"
Swafford="SwaffordL@mir.wustl.edu"
Thaler=krt7073@bjc.org
Vise=pcv3807@bjc.org
Welker="mfw0215@bjc.org"
KWhite="kdw1712@bjc.org"
SWhite="slw3913@bjc.org"
Whiting="WhitingL@mir.wustl.edu"
Witsken=rkw7166@bjc.org
Wolf="ssw9869@bjc.org"
Zobrist="baz3127@bjc.org"

emailGroup1="$Melson,$Pashia,$Picus,$Mirpacs,$Suchko"
criteria1=""

emailGroup2="$Ansel,$Battle,$Belcher,$Buffa,$Crouse,$Garcia,$Genetti,$Hedgecorth,$Lombardo,$Naes,$Oberholtzer,$Onder,$Renaud,$Wolf,$Zobrist,$Suchko"
criteria2="1=BH"

emailGroup3="$Rhoden,$Sloan,$Welker,$Suchko"
criteria3="1=WC"

emailGroup4="$Kleypas,$Melson,$Suchko"
criteria4="1=ADMIN"

emailGroup5="$Melson,$Rehagen,$Thaler,$Suchko"
criteria5="1=OOC"

emailGroup6="$Bishop,$Melson,$Stemmler,$KWhite,$SWhite,$Suchko"
criteria6="1=BHC"

reportRunTime="09:00"
daysToProcess=5

currentYear=`date '+%Y'`
currentMonth=`date '+%m'`
currentMonthAlpha=`date '+%b'`
currentDay=`date '+%d'`
currentWeekday=`date '+%a'`
currentTime=`date '+%H:%M'`

year=$currentYear
month=$currentMonth
day=$currentDay

# What was yesterday's date?
# Yesterday will be $year $mZero$month $dZero$day
    # if today is the first day of the month
    if [ $day -eq 01 ]
    then
       # if today is the  first day of the first month of the year
       if [ $month -eq 01 ]
       then
           month=12

           year=`expr $year - 1`
       else
           month=`expr $month - 1`
           if [ $month -lt 10 ]
           then
             mZero="0"
           fi
       fi
#      What was the last day of last month?
       day=`cal $month $year | awk 'NF != 0{ last = $NF }; END{ print last }'`
    else
       day=`expr $day - 1`
    fi

    if [ $day -lt 10 ]
    then
       dZero="0"
    fi

# What was last month and year (from today, not yesterday) ?
    lastMonth=`expr $currentMonth - 1`
    if [ $lastMonth -le 0 ]
    then
       lastMonth=12
       lastMonthYear=`expr $currentYear - 1`
    else
       if [ $lastMonth -lt 10 ]
       then
          lastMZero="0"
       fi
       lastMonthYear=$currentYear
    fi

# What is the earliest date to report? ( today's date minus daysToProcess)
# Note: Don't try to process more than the number of days in the shortest month.
startDay=`expr $currentDay - $daysToProcess`
if [ $startDay -lt 1 ]
then
   startMonth=`expr $currentMonth - 1`
   if [ $startMonth -lt 1 ]
   then
      startMonth=12
      startYear=`expr $currentYear - 1`
   else
      startYear=$currentYear
      if [ $startMonth -lt 10 ]
      then
         mSZero="0"
      fi
   fi
   daysInMonth=`cal $startMonth $startYear | awk 'NF != 0{ last = $NF }; END{ print last }'`
   startDay=`expr $daysInMonth + $startDay`
else
   startMonth=$currentMonth
   startYear=$currentYear
fi
if [ $startDay -lt 10 ]
then
   dSZero="0"
fi

# What was the date of 1 week ago?
weekAgoDay=`expr $currentDay - 7`
if [ $weekAgoDay -lt 1 ]
then
   weekAgoMonth=`expr $currentMonth - 1`
   if [ $weekAgoMonth -lt 1 ]
   then
      weekAgoMonth=12
      weekAgoYear=`expr $currentYear - 1`
   else
      weekAgoYear=$currentYear
      if [ $weekAgoMonth -lt 10 ]
      then
         weekAgoMonthZero="0"
      fi
   fi
   daysInMonth=`cal $weekAgoMonth $weekAgoYear | awk 'NF != 0{ last = $NF }; END{ print last }'`
   weekAgoDay=`expr $daysInMonth + $weekAgoDay`
else
   weekAgoMonth=$currentMonth
   weekAgoYear=$currentYear
fi
if [ $weekAgoDay -lt 10 ]
then
   weekAgoDayZero="0"
fi

    dayOfWeek=`echo $currentWeekday | nawk 'BEGIN	{days["Mon"]="Sunday"; days["Tue"]="Monday"; days["Wed"]="Tuesday"; days["Thu"]="Wednesday"; days["Fri"]="Thursday"; days["Sat"]="Friday"; days["Sun"]="Saturday"}	{ print days[$1] }`

/usr/local/mysql/bin/mysql -h idqc -u qcprs -pfarsi -D image_qc_db -B -e "SELECT DISTINCT facility,qc_group,station,d_station FROM station ORDER BY facility,qc_group,station;" > AAA.$$
rm -f TTT_$$ TTT5_$$
for file in `find /export/share -mtime -7 -name "EQC*.*.log" -print`
do
   echo "	" $0 "\tprocessing... " $file
   cat $file >> TTT5_$$
done
nawk -f idqcLog.awk AAA.$$ TTT5_$$ | grep -v '^$'  > TTT_$$

if [ "$currentWeekday" = "Mon" ]
then
   echo "\tcreating the Errors By Station report ..."

   nawk -f errorsByStation.awk yesterDay="$year$month$dZero$day" weekAgoDate="$weekAgoYear$weekAgoMonthZero$weekAgoMonth$weekAgoDayZero$weekAgoDay" AAA.$$ TTT5_$$ | sort -f > EEE$$

   date | nawk -f html_header.awk title="IDQC Report:Errors on Studies for $weekAgoYear $weekAgoMonth $weekAgoDay through $year $month $dZero$day" > errorsByStation$year$mZero$month$dZero$day.html
   nawk -f tab2sortTable.awk caption="IDQC Report:Errors on Studies for $weekAgoYear $weekAgoMonth $weekAgoDay through $year $month $dZero$day" header="Station<br>Name	Error<br>Message<br>Count	Total<br>Study<br>Count	Error<br>Percentage" EEE$$ >> errorsByStation$year$mZero$month$dZero$day.html
   echo "<p>Note: study UIDs with more than one modality are counted only once per station.</p>" >> errorsByStation$year$mZero$month$dZero$day.html
   echo "Generated on $currentMonthAlpha $currentDay, $currentYear at $currentTime" >> errorsByStation$year$mZero$month$dZero$day.html
   date | nawk -f html_tail.awk >> errorsByStation$year$mZero$month$dZero$day.html

   if [ "$1" = "Mail" ]
   then
      uuencode errorsByStation$year$mZero$month$dZero$day.html errorsByStation$year$mZero$month$dZero$day.html > errorsByStation$year$mZero$month$dZero$day.uue
   cat errorsByStation$year$mZero$month$dZero$day.uue | mailx -s "Errors by Station report for $dayOfWeek $month $dZero$day, $year" $Melson,$Picus,$Suchko
   rm errorsByStation$year$mZero$month$dZero$day.uue
   fi
fi

sort -u TTT_$$ > YYY_$$.xlt

# Join the QC'ed log data to the EQC study data.
nawk -f addQCinfo.awk YYY_$$.xlt $LOG/QC$lastMonthYear$lastMZero$lastMonth.log $LOG/QC$currentYear$currentMonth.log > YYY_qc$$
sort -k 1,1 -k 2,2 -k 3,3 -k 4,4 -k 8,8 -f -t "	"  YYY_qc$$ > YYY2_$$.xlt

# Remove data from before the specified time period.
echo "Remove studies performed before $startYear-$mSZero$startMonth-$dSZero$startDay"
cat YYY2_$$.xlt | nawk -v cutoffDate="$startYear-$mSZero$startMonth-$dSZero$startDay" '{FS="\t"; if ($8 > cutoffDate) print $0}' > YYY9_$$
# Remove data that was QC'ed before the last run of this report, unless it was
# done yesterday and QC'ed before this report was run yesterday.
echo "Keep studies QC'ed after $reportRunTime on $year-$mZero$month-$dZero$day or performed and QC'ed on $year-$mZero$month-$dZero$day"
cat YYY9_$$ | nawk -v cutoffDate="$year-$mZero$month-$dZero$day $reportRunTime" -v yesterday="$year-$mZero$month-$dZero$day" '{FS="\t"; if ($13 > cutoffDate || ($13 < cutoffDate && $8 >= yesterday) || $13 == "") print $0}' > YYY_$$

# Now examine specific fields and insert <br> to force formatting. We want
# more line wrapping within cells so the data will fit on one page when printed.
nawk -f splitField.awk fieldToReplace=7 FS="	" maxWidth=10 YYY_$$ > YYY2_$$
nawk -f truncateField.awk fieldToTruncate=6 maxFieldLength=7 FS="\t" YYY2_$$ > YYY3_$$
nawk -f splitField.awk fieldToReplace=6 FS="	" maxWidth=7 YYY3_$$ > YYY4_$$
nawk -f lastChance.awk fieldToReplace=6 FS="	" maxWidth=7 YYY4_$$ > YYY5_$$
# Station
nawk -f splitField.awk fieldToReplace=4 FS="	" maxWidth=7 YYY5_$$ > YYY6_$$
nawk -f lastChance.awk fieldToReplace=4 FS="	" maxWidth=7 YYY6_$$ > YYY7_$$

echo "\tcreating the IDQC reports..."
ii=1
while [ 1 ]
do
# Who says you can't have arrays in Bourne shell?
   eval currentAddr="\$emailGroup$ii"
   if [ -z "$currentAddr" ]
   then
      break
   fi
   eval currentCriteria="\$criteria$ii"
   echo "\tcriteria $ii is \" $currentCriteria \" sending to " $currentAddr
   nawk -f filterReport.awk -v criteria="$currentCriteria" YYY5_$$ > printable.$$
   nawk -f filterReport.awk -v criteria="$currentCriteria" YYY7_$$ > regular.$$

date | nawk -f html_header.awk sorting="T" title="IDQC Report:Studies for $dayOfWeek $year $month $dZero$day $additionalComment" > IDQC$year$mZero$month$dZero$day.html
nawk -f tab2sortTable.awk caption="IDQC Report:Studies for $dayOfWeek $year $month $dZero$day $additionalComment" header="Fac.	QC<br>Group	Mod	Station	Accession	MPI/MRN	Patient<br>Name	Study<br>Time	Error<br>Message\tUser and<br>disposition\tTime into QC\tTime spent<br>in QC\tTime out<br>of QC" regular.$$ >> IDQC$year$mZero$month$dZero$day.html
echo "<p>Click on a grey column header to re-sort by that column. Click again to reverse the order of the sort (from Z to A).</p>" >> IDQC$year$mZero$month$dZero$day.html
echo "<p>Studies performed on or between $startMonth $startDay, $startYear and $month $dZero$day, $year that have not been QC'ed, were QC'ed after $reportRunTime on $month $dZero$day, $year, or were performed and QC'ed on $month $dZero$day, $year before $reportRunTime.</p>" >> IDQC$year$mZero$month$dZero$day.html
echo "Generated on $currentMonthAlpha $currentDay, $currentYear at $currentTime" >> IDQC$year$mZero$month$dZero$day.html
date | nawk -f html_tail.awk >> IDQC$year$mZero$month$dZero$day.html

date | nawk -f html_header.awk sorting="No" title="IDQC Report:Studies for $dayOfWeek $year $month $dZero$day $additionalComment" >IDQC$year$mZero$month$dZero$day.printable.html
# Use all of the extra formatting EXCEPT for station (column 4).
nawk -f html_funky.awk title="IDQC Report:Studies for $dayOfWeek $year $month $dZero$day $additionalComment" header="Accession\tMPI/MRN\tPatient<br>Name\tStudy<br>Time\tError<br>Message\tUser and<br>disposition\tTime into QC\tTime spent<br>in QC\tTime out<br>of QC" printable.$$ >>IDQC$year$mZero$month$dZero$day.printable.html
echo "<p>Studies performed on or between $startMonth $startDay, $startYear and $month $dZero$day, $year that have not been QC'ed, were QC'ed after $reportRunTime on $month $dZero$day, $year, or were performed and QC'ed on $month $dZero$day, $year before $reportRunTime.</p>" >> IDQC$year$mZero$month$dZero$day.printable.html
echo "<p>Generated on $currentMonthAlpha $currentDay, $currentYear at $currentTime</p>" >> IDQC$year$mZero$month$dZero$day.printable.html
date | nawk -f html_tail.awk >> IDQC$year$mZero$month$dZero$day.printable.html

if [ "$1" = "Mail" ]
then
   echo "\tmailing the IDQC reports..."
   uuencode IDQC$year$mZero$month$dZero$day.printable.html IDQC$year$mZero$month$dZero$day.printable.html > IDQC$year$mZero$month$dZero$day.printable.uue
   uuencode IDQC$year$mZero$month$dZero$day.html IDQC$year$mZero$month$dZero$day.html > IDQC$year$mZero$month$dZero$day.uue
   echo   cat IDQC$year$mZero$month$dZero$day.printable.uue IDQC$year$mZero$month$dZero$day.uue mailx -s "IDQC reports for $dayOfWeek $month $dZero$day, $year $currentCriteria" $currentAddr
   cat IDQC$year$mZero$month$dZero$day.printable.uue IDQC$year$mZero$month$dZero$day.uue | mailx -s "IDQC reports for $dayOfWeek $month $dZero$day, $year $currentCriteria" $currentAddr
   rm IDQC$year$mZero$month$dZero$day.uue  IDQC$year$mZero$month$dZero$day.printable.uue
fi

   ii=`expr $ii + 1`
done


rm -f  TTT_$$ YYY_$$ YYY_qc$$ YYY_$$.xlt YYY2_$$.xlt YYY2_$$ YYY3_$$ YYY4_$$ YYY5_$$ YYY6_$$ YYY7_$$ YYY8_$$ YYY9_$$ TTT5_$$ AAA.$$ EEE$$ printable.$$ regular.$$

exit 0
