#!/bin/csh
#***************************************************************
# Reboot.csh                                           R Moulton
# This script is designed to be called during the boot process
# in order to clear production tmp directories and send the
# monitor a BOOT message for each production server on the
# system.  Normally, the only production server would have the
# same name as the server itself, but this is not always true.
#---------------------------------------------------------------
# 12-11-01 R Moulton Initial script
# 9-12-02  R Moulton Modified to use home env var
#***************************************************************
#------------------------------------ Clear MoveStudy.lock files
find /distributor/imgs -type f -name "MoveStudy.lock" -exec rm {} \;
#---------- All production server directories will be under this
set R = $HOME/production
if (!(-d $R)) exit 0
cd $R
foreach server (*)
#---------------------------------------------------------------
# We validate that this is a production server by looking for
# the bin, tmp, and log subdirectories, and checking for the
# Message program (which we need anyway) in the bin subdirectory
#---------------------------------------------------------------
   if (!(-d $server)) continue
   if (!(-d $server/bin)) continue
   if (!(-d $server/tmp)) continue
   if (!(-d $server/log)) continue
   if (!(-e $server/bin/Message)) continue
#-------------- Clear the tmp subdirectory and send boot message
   rm $server/tmp/* >& /dev/null
   $server/bin/Message Reboot.csh $server BOOT
#---------------------------------------------------- log reboot
   echo "Server rebooted `date`" >> $server/log/problem_log.$server
end
exit 0
