/***********************************************************************
 * Program is used to verify that input parameters represent probable
 * accn or pid values, and a current date. The first two parameters must 
 * be decimal numbers of at least 7 digits in length. The third must be
 * a numeric of which the first 8 digits represent todays date in
 * YYYYMMDD format. The script invocation of the program should be:
 *
 *  CheckStudy pid accn date_of_service
 *
 *  Returns 0 if params ok, 1 if params not OK, 2 on syntax error
 *  (including blank parameters)
 *
 ************************************************************************
 *
 * Compile and link with: gcc -g CheckStudy.c -o CheckStudy 
 *
 ***********************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>

int CheckVal(char * v)
{  unsigned char i;
   if (strlen(v) < 7) return 1;
   for (i = 0; i < strlen(v); i++) if (!isdigit(*(v+i))) return 1;
   return 0;
}

int CheckDate(char *v)
{  char today[10];
   time_t now = time(NULL);
   cftime(today,"%Y%m%d", &now);
   if (strlen(v) > 8) *(v + 8) = 0;
   return strcmp(v,today);
}
/***********************************************************************
 * main function
 **********************************************************************/
int main(int numpars, char * par[])
{  
/*----------------------------------------- Set mode from parameter 1 */
   if (numpars < 4)
   {  printf("proper syntax: CheckStudy pid accession date_of_service\n");
      return 2;
   }
   if (CheckVal(par[1])) return 1;
   if (CheckVal(par[2])) return 1;
   if (CheckDate(par[3])) return 1;
   return 0;
}
