/********************************************************************
 * Itime.c pfn
 *
 * Program to return the creation time of the file passed as a 
 * command line parameter in format YYYYMMDDHHMMSS.
 * If successful, returns status 0, otherwise status 1
 *-------------------------------------------------------------------
 * Compile: gcc Itime.c -o ITime
 *******************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

struct stat buf;
char pfn[256] = "unknown"; 
char rtime[20];      
int retv;
int main(int numpars, char * par[])
{ 
   if(numpars < 2) { printf("Need file param"); exit(1);}
   strcpy(pfn, par[1]);
   retv = stat(pfn, &buf);
   if(retv) { perror("stat call error: "); exit(1); }  
   memset(rtime,0,sizeof(rtime));
   retv = strftime(rtime, sizeof(rtime), "%Y%m%d%H%M%S", localtime(&buf.st_ctime));
   if(!retv) { printf("strftime error\n"); exit(1); }
   printf(rtime);           
   exit(0);
}
