/******************************************************************************
 * Test server for goldfinger
 * Currently set up to test Repair.  Opens, sends messages corresponding to 
 * the lines in server_messages.txt, echoing them to stdout as they are sent.
 * If a line begins with "R" or "r", echoes it and waits to receive a message,
 * echoing the received message to stdout.
 *****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <netdb.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>

char message[256]          = "null";
char host_name[256]        = " ";
char port_num[10]          = "45002";
struct hostent *phostent, shostent;
struct sockaddr_in server_socket_name;
struct sockaddr_in * sptr = &server_socket_name;
time_t timer;
time_t * ptimer = &timer; 
struct tm * ptime;
int server_socket, i, j, retval;
int on = 1;
int socket_num = 0;
FILE * fp;
char pfn[] = "server_messages.txt";
char server_message[256];
char * ptr;

cleanup()
{  if(socket_num) 
   {  retval = shutdown(socket_num, 2);
      if (retval) perror("shutdown socket");
      retval = close(socket_num);
      if (retval) perror("close socket");
   }
   retval = close(server_socket);
   if (retval) perror ("close server");
   exit (0);
}
/***********************************************************************
 * Add/Remove start and stop message characters (11 & 28)
 **********************************************************************/
Wrap()
{  char buffer[256];
   memset(buffer,0,sizeof(buffer));
   buffer[0] = 11;
   strcat(buffer,message);
   buffer[strlen(buffer)] = 28;
   strcpy(message,buffer);
}
Unwrap()
{  char buffer[256];
   int i, j;
   memset(buffer,0,sizeof(buffer));
   for (i=0,j=0; message[i]; i++)
      if (message[i] != 11 && message[i] != 28) buffer[j++] = message[i];
   strcpy(message,buffer);
}
int main()
{ 
/*------------------------------------------------- Open message file */
   fp = fopen(pfn, "r");
   if (!fp) { printf("invalid or missing server_messages.txt file\n"); exit(1); }
   
/*---------------------------------------------- Set up server socket */
   printf("Initializing server\n");
   server_socket = socket(AF_INET, SOCK_STREAM, 0);
   if (server_socket == -1) { perror("socket"); exit(1); }

   retval = setsockopt(server_socket, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on));
   if (retval) { perror("setsockopt"); cleanup(); }

   retval = gethostname(host_name, sizeof(host_name));
   if (retval) { perror("gethostname"); cleanup(); }

   phostent = gethostbyname(host_name);
   if (!phostent) { perror("gethostbyname"); cleanup(); }
   
   shostent = *phostent;
   server_socket_name.sin_family = shostent.h_addrtype;
   server_socket_name.sin_port = htons(atoi(port_num));
   server_socket_name.sin_addr = *((struct in_addr *)shostent.h_addr);

   retval = bind(server_socket, sptr, sizeof(server_socket_name));
   if (retval) { perror("bind"), cleanup(); }

   retval = listen(server_socket, 2);
   if (retval) { perror("bind"), cleanup(); }

   printf("Server initialized\n");
   printf("Waiting for connection\n");

   i = sizeof(server_socket_name);
   socket_num = accept(server_socket, sptr, &i);
   if (socket_num == -1) { perror("accept"); cleanup(); }

   retval = setsockopt(socket_num, SOL_SOCKET, SO_KEEPALIVE, &on, sizeof(on));
   if (retval) { perror("keepalive"); cleanup(); }

   printf("Connection established\n");

/*---- loop, reading instructions from command file and doing them */
   while (1)
   {  ptr = fgets(message, 256, fp);
      if (!ptr) { printf("end of messages\n"); cleanup(); }
      printf("message: %s", message);

      if (message[0] == 'R' || message[0] == 'r')

/*-------------------------------------------------- Receive message */
      {  retval = recv(socket_num, message, sizeof(message), 0);
	 if (retval < 0) { perror("recv"); cleanup(); }
	 Unwrap();
	 printf ("Received: %s\n", message);
	 continue;
      }
      else
/*----------------------------------------------------- Send message */
      {  Wrap();
	 retval = send(socket_num, message, sizeof(message), 0);
	 if (retval < 0) { perror("send"); cleanup(); }
	 printf ("Sent\n");
	 continue;
      }
   }
}
