/***********************************************************************
 * Program is used to test timing for broadcast scripts for bond and
 * goldfinger image distribution.  Its purpose is to sleep a number of
 * seconds specified by a filename in the test broadcast directory, whose
 * name is passed as std input.  The name is of the format "k999s999",
 * where the number after k is the number of k bytes the test will report
 * to the monitor, and the number after the s is the number of seconds 
 * this program will sleep, imitating a transmit time.  The script
 * invocation of the program should be:
 *
 * ls dir/k* | Snooze
 *
 ************************************************************************
 *
 * Compile and link with: gcc Snooze.c -o Snooze 
 *
 ***********************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>

/***********************************************************************
 * main function
 **********************************************************************/
int main()
{  char a[12];
   int c, s_found = 0, i = 0;
   memset (a,0,sizeof(a));
   while ((c = getchar()) != EOF)
   {  if(!s_found)
      {  if((char)c == 's') s_found = 1;
         continue;
      }
      if(!isdigit(c) || i > 9) break;
      a[i++] = c;
   }
   c = atoi(a);
   sleep(c);
   exit(0);
}
