/****************************************************************************************
 * Compile with gcc -g hippalog.c -o hippalog `pkg-config --cflags --libs msrdLogPrs`
 ***************************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>

#include <dbg.h>

/*------------------------------ working storage --------------------------------------*/
#define DATE_STRING "DATE_STRING"
#define BUFSIZE 10240
static FILE * debug_fp;
static char * tmp;
static char * dlg;
static char raw_log_pfn[256];
static FILE * raw_log_fp;
static char log_dir[64];
static char log_pfn[64];
static FILE * log_fp;

static char * skip[] = {
   "DRIVE_STATUS",
   "DB_SIZE_OK",
   "BAD_OBJECT_CNT"
};
static char sk, skips = sizeof(skip) / sizeof(char *);




/****************************************************************************************
 ****************************************************************************************
 ********************************** main function ***************************************
 ****************************************************************************************
 ***************************************************************************************/
int main(int argc, char * argv[])
{  char * p;
   DIR * tmp_dp;
   struct dirent * tmp_de;
   time_t now;
   struct tm * tm;
   int mo = 0, da = 0, yr = 0, r;
   char raw_buff[BUFSIZE], buff[BUFSIZE], *rst, todays_date[16], last_record[BUFSIZE],
      log_file_name[14], new_log_file_name[14], flag;
   now = time(NULL);
   tm = localtime(&now);
   sprintf(todays_date,"%04d.%02d.%02d", tm->tm_year + 1900, tm->tm_mon +1, tm->tm_mday);
   CLEAR(buff);
   CLEAR(log_file_name);
   umask(007);
   
/*-------------------------------------------------- If par 1 exists, it is debug file */
   if (argc > 1 && strlen(argv[1])) debug_fp = debug_on(argv[1]);

/*--------------------- find tmp directory, validate that it exists and is a directory */
   if (!(p=getenv("DLG"))) dbg_exit("DLG environment variable not defined", 1);
   STR(dlg,p);
   if (!(tmp_dp=opendir(dlg))) dbge_exit("DLG opendir",1);

/****************************************************************************************
 * This loop processes each msrd#.log file in the TMP directory
 ***************************************************************************************/
   while (tmp_de = readdir(tmp_dp))
   {
/*------------------------------ Skip any files in directory which are not "msrd#.log" */
      sprintf(raw_log_pfn,"%s/%s",tmp,tmp_de->d_name); 
      if (access(raw_log_pfn, R_OK)) 
      {  sprintf(em,"Can't read %s", raw_log_pfn); dbg(em);
         continue;
      }
      if (!(raw_log_fp=fopen(raw_log_pfn,"r")))
      {  sprintf(em,"open %s", raw_log_pfn), dbge(em);
         continue;
      }
/*------------------------------------------------------------- Processed log directory */
      sprintf(log_dir,"/distributor/logs/hippa/%s",strtok(tmp_de->d_name,"."));
      if (access(log_dir, F_OK) && mkdir(log_dir,0770)) 
      {  sprintf(em,"mkdir %s", log_dir); dbge(em);
         continue;
      }
      strcat(log_dir,"/");
            
/*------------------------------------------------- finished with current raw log file */
      if (ferror(raw_log_fp)) dbge("raw log I/O");
      fclose(raw_log_fp);
      remove(raw_log_pfn);
      if (log_fp) fclose(log_fp);
      CLEAR(log_file_name);
   }
   closedir(tmp_dp);
   return (0);
}
