#!/bin/csh

#********************************************************************
# RebuildQCDB.csh                                           R Moulton
# Script to rebuild image_qc_db. The station and login tables are
# loaded from tab delimited files which are in turn generated from
# an Excel spreadsheet. The study table is build from files generated
# by simple_storage and placed in the study directory in the EQCHold
# directory tree.  They are cat'd together and then loaded.
#********************************************************************
set BIN = `pwd`
set SQL = $TMP/RebuildQCDB.sql
set STUDY = $TMP/RebuildQCStudy.tmp
echo use image_qc_db\; > $SQL
#--------------------------------- rebuild login if login.txt present
if (-e $BIN/login.txt) then
   dos2unix $BIN/login.txt $BIN/login.txt >& /dev/null
   echo DELETE FROM login\; >> $SQL
   echo LOAD DATA LOCAL INFILE \"$BIN/login.txt\" INTO TABLE login\; >> $SQL
endif
#----------------------------- rebuild station if station.txt present
if (-e $BIN/station.txt) then
   dos2unix $BIN/station.txt $BIN/station.txt >& /dev/null
   echo DELETE FROM station\; >> $SQL
   echo LOAD DATA LOCAL INFILE \"$BIN/station.txt\" INTO TABLE station\; >> $SQL
endif
#------------------------------- rebuild resend if resend.txt present
if (-e $BIN/resend.txt) then
   dos2unix $BIN/resend.txt $BIN/resend.txt >& /dev/null
   echo DELETE FROM resend\; >> $SQL
   echo LOAD DATA LOCAL INFILE \"$BIN/resend.txt\" INTO TABLE resend\; >> $SQL
endif
#---------- rebuild study from .dat records if "study" is first param
if ("$1" == "study") then
   rm $STUDY
   touch $STUDY
   find /distributor/imgs/EQChold -name "QCStudy.dat" -exec cat {} >> $STUDY \;
   echo LOAD DATA LOCAL INFILE \"$STUDY\" REPLACE INTO TABLE study\; >> $SQL
endif
if (-e $BIN/login.txt) echo SELECT \* FROM login\; >> $SQL
if (-e $BIN/station.txt) echo SELECT \* FROM station\; >> $SQL
if (-e $BIN/resend.txt) echo SELECT \* FROM resend\; >> $SQL
if ("$1" == "study") echo SELECT \* FROM study\; >> $SQL
$MYSQL -u root -pgloria  < $SQL
rm $SQL $STUDY
