#************************************************************************************
# simple_storage.gdb                                                        R Moulton
# gdb -x simple_storage.gdb
#------------------------------------------------------------------------------------
# gdb command file for testing modified versions of simple_storage.  When debugging 
# simple_storage, do NOT set the sticky bit or change the owner to root.  Also, run 
# using a port higher than 1024, as shown below. (gdb will not work for setuid 
# programs).
#------------------------------------------------------------------------------------
# Unfortunately, follow_fork_mode will not work properly on solaris, even though you
# will find comments on the internet to the effect that it does.  As a workaround,
# this line of code has been added to simple_storage right after the fork:
#   if (pid) printf("pid=%d\n", pid); else sleep(60);
# This will cause the parent process to print the pid of the child process, and the
# child process to sleep for 1 minute after it is invoked.  To debug the child prs:
#   1. load gdb for simple_storage, using command line above.
#   2. run
#   3. Do any debugging you may want to do on the parent process.
#   4. When complete with parent, enter "detach" at break, and confirm.
#   5. Start send of study. Parent will print pid.
#   6. attach pid - to pick up debugging on child
#------------------------------------------------------------------------------------
# Also, since most debugging will be in the child process, you need to remember to
# kill the parent process after each run, so that the port won't block on the restart
#************************************************************************************
dir /export/home/spectrum/masters/qc           
dir /export/home/spectrum/ctn/facilities/mircs
file /export/home/spectrum/masters/qc/Run           
set print elements 0
set print null-stop
set args Test.msg
