/****************************************************************************************
 * log_purge.c Standard log file purging program                                R Moulton
 * Designed to be run as a cron job or forked as a process, to perform the periodic purge
 * function for standard log files.  Can purge a single log using command line parameters
 * the first one being the .ini file pfn, the second the log name.  Will also look for a
 * file on stdin, which would have one or more lines for logs to be processed. Each line
 * would have the .ini pfn and the log name separated by spaces.
 *---------------------------------------------------------------------------------------
 * compile with gcc -g log_purge.c -o log_purge `pkg-config --cflags --libs log_purge`
 ***************************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "dbg.h"
#include "ini.h"
#include "log.h"

int main(int argc, char * argv[])
{  char buf[1024], * p;    
/*--------------------------------------------- log purge on cmd arguments, if present */ 
   if (argc >= 3)
   {  if (!logInitialize(argv[1]))
         logPurge(argv[2]);
   }
/*------------------------------------------------------------------------------ stdin */
   while (fgets(buf, sizeof(buf), stdin))
   {  p = strtok(buf," \n");
      if (p && !logInitialize(p))
      {  p = strtok(NULL," \n");
         if (p) logPurge(p);
      }
   }
}

