/***********************************************************************************
* Test hl7 routines
* gcc -g hl7query_test.c dbg.c hl7.c hl7query.c -o hl7query_test -lsocket -lnsl
***********************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "hl7query.h"
#include "dbg.h"

static struct _hl7_accn_query_ acq;
static struct _hl7_mpi_query_ mpiq;
static struct _hl7_mpi_query_exam_ * x;

dump_msg(char * hdr, char * msg)
{	char *p;
	printf("  %s\n", hdr);
	if (msg[0] == 11)
	{	msg[0] = '.';
		printf("    <SB> found at msg[0]\n");
	}
	if (msg[strlen(msg) -1] == 28)
	{	msg[strlen(msg) -1] = '.';
		printf("    <EB> found at msg[end]\n");
	}
	while (p = strtok(msg,"\r"))
	{	printf("     %s\n", p);
		msg = NULL;
	}
}

int main(int numpars, char *par[])
{	int ret = 0, i, f, r, c, sc;
	char msg[10000];
	char msg_out[40000];
   char * p;

   debug_on("stdout");

   printf("selecting server 0\n");
   p = hl7QSelectServer(0, -1, 0);
   printf("returned %s\n", p);
/*------------------------------------------------------------------------------------------------------------
	memset(msg,0,sizeof(msg));
	strcat(msg,"MSH|^~\\&|RAD RESULTS|RIQ1|RAD RESULTS|RIQ1|20010501212000||QRY^Q01|12345|P|2.1||\r");
	strcat(msg,"QRD|20010501212000|D|I|IWCD|||150^LI|9999999|RES|LIST||\r");
   strcpy(msg_out,msg);
   dump_msg("Query....", msg_out);   

	memset(msg_out,0,sizeof(msg_out));
   ret = hl7MsgQuery(msg, msg_out, sizeof(msg_out));
   printf("return = %d\n", ret);
	
   dump_msg("Reply....", msg_out);

 -----------------------------------------------------------------------------------------------------*/  
   memset((char *)&acq,0,sizeof(acq));
   acq.accn = 9261970;
   printf("Calling accn query for %d\n", acq.accn);
   ret = hl7AccnQuery(&acq);
   printf("returned %d\n", ret);
   printf("  accn     = %d\n", acq.accn);
   printf("  mpi      = %d\n", acq.mpi);
   if (acq.dnumber)   printf("  dnumber  = %s\n", acq.dnumber);
   if (acq.visit)     printf("  visit    = %s\n", acq.visit);
   if (acq.pname)     printf("  pname    = %s\n", acq.pname);
   if (acq.dob)       printf("  dob      = %s\n", acq.dob);
   if (acq.sex)       printf("  sex      = %s\n", acq.sex);
   if (acq.exam)      printf("  exam     = %s\n", acq.exam);
   if (acq.exam_desc) printf("  exam_desc= %s\n", acq.exam_desc);
   if (acq.start_time)printf("  scheduled= %s\n", acq.start_time);
   if (acq.status)    printf("  status   = %s\n", acq.status);
   if (acq.time)      printf("  time     = %s\n", acq.time);

   p = hl7QSelectServer(5, -1, 0);
   printf("returned %s\n", p);

   memset((char *)&mpiq,0,sizeof(mpiq));
   mpiq.mpi = 5458401;
   printf("Calling MPI query for %d\n", mpiq.mpi);
   ret = hl7MPIQuery(&mpiq);
   printf("returned %d\n", ret);

   printf("  mpi       = %d\n", mpiq.mpi);
   printf("  num_exams = %d\n", mpiq.num_exams);
   if (mpiq.num_exams) {
   printf("  ------- -------------- ------------------ -- -\n");
   for (x = mpiq.exam; x->code; x++)
   {  printf("  %7d", x->accn);
      if (x->code) printf(" %14s", x->code);
      if (x->desc) printf(" %18s", x->desc);
      if (x->facility) printf(" %2s", x->facility);
      if (x->status) printf(" %s\n", x->status);
   } 
   }
}
