#ifndef _EQC_ERRORS_H_
#define _EQC_ERRORS_H_

/******************************************************************************
 * EQCerrors.h                                                        R Moulton
 * Header file for Emageon QC errors.  Defines error constants and a struct of
 * error text messages. Functions allow user to encode and decode the errors
 * from EQC_errno.
 *****************************************************************************/

unsigned long EQC_error;  /* This is packed errors */

/*------------------------------ Error Constants ----------------------------*/
#define EQCE_STUDY_DATE         0
#define EQCE_IMAGE_DATE         1
#define EQCE_STUDY_TIME         2
#define EQCE_ACCESSION_NUMBER   3
#define EQCE_MODALITY           4
#define EQCE_INSTITUTION_NAME   5
#define EQCE_STATION_NAME       6
#define EQCE_STUDY_DESCRIPTION  7
#define EQCE_PATIENT_NAME       8
#define EQCE_PATIENT_ID         9
#define EQCE_FACILITY          10
#define EQCE_PATIENT_DOB       11
#define EQCE_PATIENT_SEX       12
#define EQCE_OTHER_ID          13
#define EQCE_BODY_PART         14
#define EQCE_STUDY_UID         15
#define EQCE_SERIES_UID        16
#define EQCE_IMAGE_UID         17
#define EQCE_VISIT_NUMBER      18
#define EQCE_SCHED_DATE        19
#define EQCE_SCHED_TIME        20
#define EQCE_EXAM_CODE         21
#define EQCE_EXAM_SCHEME       22
#define EQCE_EXAM_DESCRIPTION  23
#define EQCE_ID_ACCN_MISMATCH  24
#define EQCE_ACCN_CANCELED     25
#define EQCE_REF_PHYSICIAN     26
#define EQCE_QUERY_FAILED      27
#define EQCE_PALETTE_COLOR     28

/*----------------------------- Function Prototypes -------------------------*/
void EQCClearErrors(void);
void EQCSetError(char error);
int EQCIsErrorSet(char error);
unsigned long EQCGetErrorBit(char error);
char * EQCGetErrorString(char error, char * prefix, char tag, char set);
char * EQCGetErrorsMsg(char * prefix, char tags);
char * EQCGetQCErrorsMsg(char include_repairable_comment);
int EQCQCRepairable(void);


#endif
